
import java.lang.*;


public class getblk{

  static globals jva;
  static indicesh jvaind;
  static sactblsh jvasach;
  static getvlch jvavlc;
  static sac jvasac;
			
  public static void getblock(int comp, int mode){

    int val, i, j, sign;
    int st;
    long code;
    vlctabh tab;
    int run, last, level, QP;
    short bp[];

    bp = jva.ld.block[comp];
    
    /* Hack for boolean to int conversion */
    if (mode == 0)
      st = 1;
    else
      st = 0;
    for (i = st; ;i++){
      code = jva.NPACGetBits.showbits(12);
      if (code >= 512)
	tab = jvavlc.DCT3Dtab0[(int) ((code >> 5) - 16)];
      else
	if (code >= 128)
	  tab = jvavlc.DCT3Dtab1[(int) (code >> 2) - 32];
	else
	  if (code >= 8)
	    tab = jvavlc.DCT3Dtab2[(int) (code >> 0) - 8];
	  else {
	    if (jva.quiet == 0)
	      System.err.println("Invalid huffman code in getblock()");
	    jva.fault = 1;
	    return;
	  }
      
      jva.NPACGetBits.flushbits(tab.len);
      
      run = (tab.val >> 4) & 255;
      level = tab.val & 15;
      last = (tab.val >> 12) & 1;

      if (jva.trace != 0){
	System.out.print(" (");
	jva.NPACH263Dec.printbits(code, 12, tab.len);
      }
      
      if (tab.val == jva.tmnh.ESCAPE){
	if (jva.trace != 0){
	  System.out.print(" (");
	  jva.NPACH263Dec.printbits(jva.NPACGetBits.showbits(1), 1, 1);
	}
	
	last = (int) jva.NPACGetBits.getbits1();
	
	if (jva.trace != 0){
	  System.out.print(" (");
	  jva.NPACH263Dec.printbits(jva.NPACGetBits.showbits(6), 6, 6);
	}

	run = (int) jva.NPACGetBits.getbits(6);
	i += run;

	if (jva.trace != 0){
	  System.out.print(" (");
	  jva.NPACH263Dec.printbits(jva.NPACGetBits.showbits(8), 8, 8);
	}

	level = (int) jva.NPACGetBits.getbits(8);

	if (level >= 128)
	  sign = 1;
	else
	  sign = 0;
	
	if (sign == 1)
	  val = 256 - level;
	else
	  val = level;
      }
      else{
	i += run;
	val = level;
	sign = (int) jva.NPACGetBits.getbits(1);
	if (jva.trace != 0)
	  System.out.print(sign);
      }

      if (i >= 64){
	if (jva.quiet == 0)
	  System.err.println("DCT coeff index (i) out of bounds");
	jva.fault = 1;
	return;
      }
      
      if (jva.trace != 0 && sign == 0)
	System.out.println("): " + run + "/" + val);
      else
	if (jva.trace != 0 && sign != 0)
	  System.out.println("): " + run + "/" + (int) (-1 * val));

      j = jva.zig_zag_scan[i];

      if (comp >= 6)
	QP = jva.mmax(1, jva.mmin(31, ((jva.bquant_tab[jva.bquant] * jva.quant) >> 2) ) );
      else
	QP = jva.quant;
      
      if ((QP % 2) == 1){
	if (sign != 0)
	  bp[j] = (short) (-1 * (QP * ((2 * val) + 1)));
	else
	  bp[j] = (short) (QP * ((2 * val) + 1));
      }
      else{
	if (sign != 0)
	  bp[j] = (short) (-1 * (QP * ((2 * val) + 1) - 1));
	else
	  bp[j] = (short) (QP * ((2 * val) + 1) - 1);
      }

      if (last > 0){
	if (jva.trace != 0)
	  System.out.println("last");
	return;
      }
    }
  }

  public static void get_sac_block(int comp, int ptype){

    int position=0;
    int TCOEF_index, symbol_word;
    int last[], QP, i, j;
    short bp[];
    runcoefh DCTcoef = new runcoefh();

    last = new int[1];

    last[0] = 0;
    
    bp = jva.ld.block[comp];
    
    if (ptype == 0)
      i = 1;
    else
      i = 0;
    
    while (last[0] == 0){
      position++;
      if (ptype == 0)
	TCOEF_index = DecodeTCoef(position, 1);
      else
	TCOEF_index = DecodeTCoef(position, 0);

      if (TCOEF_index == jva.tmnh.ESCAPE_INDEX){
	if (ptype == 0)
	  DCTcoef = Decode_Escape_Char(1, last);
	else
	  DCTcoef = Decode_Escape_Char(0, last);
	if (jva.trace != 0)
	  System.out.print("ESC: ");
      }
      else{
	symbol_word = jvaind.tcoeftab[TCOEF_index];

	DCTcoef = vlc_word_decode(symbol_word, last);
      }

      if (jva.trace != 0){
	System.out.println("val: " + DCTcoef.val + " run: " + DCTcoef.run + 
			   " sign: " + DCTcoef.sign + " last: " + last[0]);
      }

      i += DCTcoef.run;
      
      j = jva.zig_zag_scan[i];

      i++;
      
      if (comp >= 6)
	QP = jva.mmax(1, jva.mmin(31, ((jva.bquant_tab[jva.bquant] * jva.quant) >> 2) ) );
      else
	QP = jva.quant;

      
      if ((QP % 2) == 1){
	if (DCTcoef.sign != 0)
	  bp[j] = (short) (-1 * (QP * ((2 * DCTcoef.val) + 1)));
	else
	  bp[j] = (short) (QP * ((2 * DCTcoef.val) + 1));
      }
      else{
	if (DCTcoef.sign != 0)
	  bp[j] = (short) (-1 * (QP * ((2 * DCTcoef.val) + 1) - 1));
	else
	  bp[j] = (short) (QP * ((2 * DCTcoef.val) + 1) - 1);
      }
    }
    
    return;
  }

  public static runcoefh vlc_word_decode(int symbol_word, int last[]){

    int sign_index;
    runcoefh DCTcoef = new runcoefh();

    last[0] = (symbol_word >> 12) & 01;

    DCTcoef.run = (symbol_word >> 4) & 255;

    DCTcoef.val = (symbol_word) & 15;

    sign_index = jvasac.decode_a_symbol(jvasach.cumf_SIGN);

    DCTcoef.sign = jvaind.signtab[sign_index];

    return DCTcoef;
    
  }

  public static runcoefh Decode_Escape_Char(int intra, int last[]){

    int last_index, run, run_index, level, level_index;
    runcoefh DCTcoef = new runcoefh();

    if (intra != 0){
      last_index = jvasac.decode_a_symbol(jvasach.cumf_LAST_intra);
      last[0] = jvaind.last_intratab[last_index];
    }
    else{
      last_index = jvasac.decode_a_symbol(jvasach.cumf_LAST);
      last[0] = jvaind.lasttab[last_index];
    }

    if (intra != 0)
      run_index = jvasac.decode_a_symbol(jvasach.cumf_RUN_intra);
    else
      run_index = jvasac.decode_a_symbol(jvasach.cumf_RUN);

    run = jvaind.runtab[run_index];

    DCTcoef.run = run;
    
    if (intra != 0)
      level_index = jvasac.decode_a_symbol(jvasach.cumf_LEVEL_intra);
    else
      level_index = jvasac.decode_a_symbol(jvasach.cumf_LEVEL);

    if (jva.trace != 0)
      System.out.println("Level_idx: " + level_index);

    level = jvaind.leveltab[level_index];
    
    if (level >= 128)
      level -= 256;

    if (level < 0){
      DCTcoef.sign = 1;
      DCTcoef.val = java.lang.Math.abs(level);
    }
    else{
      DCTcoef.sign = 0;
      DCTcoef.val = level;
    }

    return DCTcoef;
  }

  public static int DecodeTCoef(int position, int intra){

    int index;

    switch(position){
    case 1:
      if (intra != 0)
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEF1_intra);
      else
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEF1);
      break;

    case 2:
      if (intra != 0)
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEF2_intra);
      else
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEF2);
      break;
      
    case 3:
      if (intra != 0)
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEF3_intra);
      else
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEF3);
      break;
      
    default:
      if (intra != 0)
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEFr_intra);
      else
	index = jvasac.decode_a_symbol(jvasach.cumf_TCOEFr);
      break;
    }
    
    return index;
  }

  public void testFunc(){

    System.out.println("Getblk test function called.");
    jvasac.testFunc();
  }

}
