
import java.lang.*;


public class getvlc{
  
  static globals jva;
  static indicesh jvaind;
  static sactblsh jvasach;
  static getvlch jvavlc;
  static sac jvasac;

  public static int getTMNMV(){

    int code;

    if (jva.trace != 0)
      System.out.print("motion_code (");

    if (jva.NPACGetBits.getbits1() != 0){
      if (jva.trace != 0)
	System.out.println("1): 0");
      return 0;
    }

    if ((code = (int) jva.NPACGetBits.showbits(12)) >= 512){
      code = (code >> 8) - 2;
 
      jva.NPACGetBits.flushbits(jvavlc.TMNMVtab0[code].len);
      
      if (jva.trace != 0){
	System.out.print("0");
	jva.NPACH263Dec.printbits((long) code + 2, 4, jvavlc.TMNMVtab0[code].len);
	System.out.println("): " + jvavlc.TMNMVtab0[code].val);
      }

      return jvavlc.TMNMVtab0[code].val;
    }

    if (code >= 128){
      code = (code >> 2) - 32;
      jva.NPACGetBits.flushbits(jvavlc.TMNMVtab1[code].len);
      
      if (jva.trace != 0){
	System.out.print("0");
	jva.NPACH263Dec.printbits((long) code + 32, 10, jvavlc.TMNMVtab1[code].len);
	System.out.println("): " + jvavlc.TMNMVtab1[code].val);
      }

      return jvavlc.TMNMVtab1[code].val;
    }

    if ((code -= 5) < 0){

      if (jva.quiet == 0)
	System.err.println("Invalid motion vector code");
      jva.fault = 1;
      return 0;
    }
    
    jva.NPACGetBits.flushbits(jvavlc.TMNMVtab2[code].len);
    
    if (jva.trace != 0){
      System.out.print("0");
      jva.NPACH263Dec.printbits((long) code + 5, 12, jvavlc.TMNMVtab2[code].len);
      System.out.println("): " + jvavlc.TMNMVtab2[code].val);
    }

    return jvavlc.TMNMVtab2[code].val;
  }

  public static int getMCBPC(){

    int code;

    if (jva.trace != 0)
      System.out.print("MCBPC (");
    
    code = (int) jva.NPACGetBits.showbits(9);

    if (code == 1){
      if (jva.trace != 0)
	System.out.println("000000001): stuffing");
      jva.NPACGetBits.flushbits(9);
      return -1;
    }

    if (code == 0){
      if (jva.quiet == 0)
	System.err.println("Invalid MCBPC code.");
      
      jva.fault = 1;
      return 0;
    }

    if (code >= 256){
      jva.NPACGetBits.flushbits(1);
      if (jva.trace != 0)
	System.out.print("1): 0");
      
      return 0;
    }

    jva.NPACGetBits.flushbits(jvavlc.MCBPCtab[code].len);

    if (jva.trace != 0){
      jva.NPACH263Dec.printbits((long) code, 9, jvavlc.MCBPCtab[code].len);
      System.out.println("): " + jvavlc.MCBPCtab[code].val);
    }

    return jvavlc.MCBPCtab[code].val;

  }

  public static int getMODB(){

    int code;
    int MODB;

    if (jva.trace != 0)
      System.out.print("MODB (");
    
    code = (int) jva.NPACGetBits.showbits(2);
    
    if (code < 2){
      if (jva.trace != 0)
	System.out.println("0): MODB = 0");
      
      MODB = 0;
      
      jva.NPACGetBits.flushbits(1);
    }
    else
      if (code == 2){
	if (jva.trace != 0)
	  System.out.println("10): MODB = 1");
	
	MODB = 1;
	jva.NPACGetBits.flushbits(2);
      }
      else{
	if (jva.trace != 0)
	  System.out.println("11): MODB = 2");
	
	MODB = 2;
	jva.NPACGetBits.flushbits(2);
      }
    
    return MODB;
  }

  public static int getMCBPCintra(){

    int code;

    if (jva.trace != 0)
      System.out.print("MCBPCintra (");

    code = (int) jva.NPACGetBits.showbits(9);

    if (code == 1){
      if (jva.trace != 0)
	System.out.println("000000001): stuffing");
      
      jva.NPACGetBits.flushbits(9);
      return -1;
    }

    if (code < 8){
      if (jva.quiet == 0)
	System.err.println("Invalid MCBPCintra code");
      
      jva.fault = 1;
      return 0;
    }
  
    code >>= 3;

    if (code >= 32){
      jva.NPACGetBits.flushbits(1);
      if (jva.trace != 0)
	System.out.println("1): 3");
      
      return 3;
    }
    
    jva.NPACGetBits.flushbits(jvavlc.MCBPCtabintra[code].len);
    
    if (jva.trace != 0){
      jva.NPACH263Dec.printbits((long) code, 6, jvavlc.MCBPCtabintra[code].len);
      System.out.println("): " + jvavlc.MCBPCtabintra[code].val);
    }

    return jvavlc.MCBPCtabintra[code].val;
  }

  public static int getCBPY(){

    int code;
    
    if (jva.trace != 0)
      System.out.print("CBPY (");

    code = (int) jva.NPACGetBits.showbits(6);

    if (code < 2){
      if (jva.quiet == 0)
	System.err.println("Invalid CBPY code");

      jva.fault = 1;
      return -1;
    }

    if (code >= 48){
      jva.NPACGetBits.flushbits(2);
      if (jva.trace != 0)
	System.out.println("11): 0");
      return 0;
    }

    jva.NPACGetBits.flushbits(jvavlc.CBPYtab[code].len);

    if(jva.trace != 0){
      jva.NPACH263Dec.printbits((long) code, 6, jvavlc.CBPYtab[code].len);
      System.out.println("): " + jvavlc.CBPYtab[code].val);
    }

    return jvavlc.CBPYtab[code].val;
  }
    
}
