


import java.lang.*;
import java.awt.*;
import java.awt.image.*;
import java.applet.*;
import java.io.*;

public class h263dec extends Applet implements Runnable{

  static globals mainglobals;
  static sactblsh temp;
  static int a;
  static String args[];
  Image img;
  MemoryImageSource source;
  Graphics g;
  
  public void init(){
    
    boolean res;
    
    resize(176, 144);

    mainglobals = new globals();
    
    mainglobals.initGlobals();

    if (getColorModel() == ColorModel.getRGBdefault())
      System.out.println("Color model is RGB default.");
    else
      if (getColorModel() == null)
	System.out.println("Unknown model.");

    mainglobals.cmodel = getColorModel();
    
    source = new MemoryImageSource(176, 
				   144,
				   mainglobals.cmodel,
				   mainglobals.pix, 0, 
				   176);
    
    img = createImage(source);
   

    mainglobals.fileName = getParameter("FILENAME");
    mainglobals.NPACVodClient.setupConnections();
    mainglobals.NPACVodClient.sendCommand(mainglobals.NPACVodJava.VODLoadMovie);
    mainglobals.NPACVodClient.sendCommand(mainglobals.NPACVodJava.VODPlay);

    System.out.println("Finished initialising globals.");
    
  }

  public void start(){
   
   if (mainglobals.kicker == null){
     mainglobals.kicker = new Thread(this);
     mainglobals.kicker.start();
   }

   if (mainglobals.net == null){
     mainglobals.net = new Thread(mainglobals.NPACVodClient);
     mainglobals.net.start();
   }
   
 }
  
  public void stop(){
    
   if (mainglobals.kicker != null){
       mainglobals.kicker.stop();
       mainglobals.kicker = null;
   }

   if (mainglobals.net != null){
     mainglobals.net.stop();
     mainglobals.net = null;
   }

  }

  public void paint(Graphics g){

   g.drawImage(img, 0, 0, 176, 144, this);

  }

  public void update(Graphics g){



  }

  public void run(){

    int len;
    int first, framenum[];
    
    
    framenum = new int[1];
    
    mainglobals.NPACH263Dec.options(args);
    
    len = mainglobals.fileName.length();
    
    mainglobals.outputname = new StringBuffer(len);
    mainglobals.outputname.append(mainglobals.fileName);
    
    first = 1;
    System.out.println("In h263dec run.");

    mainglobals.NPACGetBits.initbits();
    framenum[0] =mainglobals.tr_framenum[0] = 0;
    g = getGraphics();

    while (mainglobals.NPACGetHdr.getheader() != 0){
      if (first != 0){
	mainglobals.NPACH263Dec.initdecoder();
	first = 0;
	mainglobals.NPACDither.init_display();
	
	if (mainglobals.cmodel.getPixelSize() < 24){
	  source = new MemoryImageSource(176, 
					 144,
					 mainglobals.cmodel,
					 mainglobals.pix, 0, 
					 176);
	  
	  img = createImage(source);
	 
	}
	
      }
      
      mainglobals.NPACGetPic.getpicture(framenum);
      framenum[0]++;
      mainglobals.tr_framenum[0]++;                                       
  
      img = createImage(source);
      g.drawImage(img, 0, 0, 176, 144, this);
    }

  }
  
  
}
