
import java.lang.*;


public class idctref{

  static globals jva;
  static double PI = 3.14159265358979323846;
  static double c[][] = new double[8][8];

  public static void init_idctref(){

    int freq, time;
    double scale;

    for (freq = 0; freq < 8; freq++){
      if (freq == 0)
	scale = java.lang.Math.sqrt(0.125);
      else
	scale = 0.5;

      for (time = 0; time < 8; time++)
	c[freq][time] = scale * java.lang.Math.cos((PI / 8.0) * freq * (time + 0.5));
    }
  }

  public static void idctref(short block[]){


    int i, j, k, v;
    double partial_product;
    double tmp[] = new double[64];

    for (i=0; i<8; i++)
      for (j=0; j<8; j++){
	
	partial_product = 0.0;
	
	for (k=0; k<8; k++)
	  partial_product+= c[k][j]*block[(8*i)+k];

	tmp[(8*i)+j] = partial_product;
      }

    /* Transpose operation is integrated into address mapping by switching 
       loop order of i and j */
    
    for (j=0; j<8; j++)
      for (i=0; i<8; i++){
	
	partial_product = 0.0;
	
	for (k=0; k<8; k++)
	  partial_product+= c[k][i]*tmp[(8*k)+j];
	
	v = (int) (java.lang.Math.floor(partial_product+0.5));
	if (v < -256)
	  block[(8*i) + j] = -256;
	else{
	  if (v > 255)
	    block[(8*i) + j] = 255;
	  else
	    block[(8*i) + j] = (short) v;
	}
      }
  }

}
