
import java.lang.*;

public class getpic{

  static globals jva;
  static indicesh jvaind;
  static sactblsh jvasach;
  static getvlch jvavlc;
  
  static int comp;
  static int MBA, MBAmax;
  static int bx, by;
  
  static int COD=0,MCBPC, CBPY, CBP=0, CBPB=0, MODB=0, Mode=0, DQUANT;
  static int COD_index, CBPY_index, MODB_index, DQUANT_index, MCBPC_index;
  static int INTRADC_index, YCBPB_index, UVCBPB_index, mvdbx_index, mvdby_index;
  static int mvx, mvy, mvy_index, mvx_index, pmv0, pmv1, xpos, ypos, gob, i,k;
  static int mvdbx=0, mvdby=0, pmvdbx, pmvdby, gfid, YCBPB, UVCBPB, gobheader_read;
  static int startmv,stopmv,offset,bsize,last_done=0,pCBP=0,pCBPB=0,pCOD=0;
  static int DQ_tab[] = {-1,-2,1,2};
  static short bp[];

  public static void getpicture(int framenum[]){

    int i;
    int tmp[];
    
    System.out.println("Decompressing frame ....." + framenum[0]);

    for (i = 0; i < 3; i++){
      tmp = jva.oldrefframe[i];
      jva.oldrefframe[i] = jva.refframe[i];
      jva.refframe[i] = tmp;
      jva.newframe[i] = jva.refframe[i];
    }
    
    if ((jva.mv_outside_frame != 0) && (framenum[0] > 0)){
      make_edge_image(jva.oldrefframe[0], jva.edgeframeorig[0], 
		      jva.edgeframe[0], 
		      jva.coded_picture_width, jva.coded_picture_height,32);
      make_edge_image(jva.oldrefframe[1],jva.edgeframeorig[1], jva.edgeframe[1],
		      jva.chrom_width, jva.chrom_height,16);
      make_edge_image(jva.oldrefframe[2],jva.edgeframeorig[2], jva.edgeframe[2],
		      jva.chrom_width, jva.chrom_height,16);
    }

    getMBs(framenum[0]);
    
    if (jva.pb_frame != 0) {
      if ((jva.expand != 0) && (jva.outtype == jva.T_X11)) {
	interpolate_image(jva.bframe[0], jva.exnewframe[0],
			  jva.coded_picture_width, jva.coded_picture_height);
	interpolate_image(jva.bframe[1], jva.exnewframe[1], 
			  jva.chrom_width, jva.chrom_height);
	interpolate_image(jva.bframe[2], jva.exnewframe[2], 
			  jva.chrom_width, jva.chrom_height);
	
	jva.NPACStore.storeframe(jva.exnewframe, framenum[0]);	
      }
      else
	jva.NPACStore.storeframe(jva.bframe, framenum[0]);
      
      framenum[0] += jva.pb_frame;

      /* Here we have USE TIME TO throttle rate. Don't think we will need
	 to throttle this thing as java is going to run like a dog for this
	 codec. Is a wish that we could run this fast enough to throttle
	 it! :) */
    }

    if ((jva.expand != 0) && (jva.outtype == jva.T_X11)) {
      interpolate_image(jva.newframe[0], jva.exnewframe[0],
			jva.coded_picture_width, jva.coded_picture_height);
      interpolate_image(jva.newframe[1], jva.exnewframe[1], 
			jva.chrom_width, jva.chrom_height);
      interpolate_image(jva.newframe[2], jva.exnewframe[2], 
			jva.chrom_width, jva.chrom_height);
      
      jva.NPACStore.storeframe(jva.exnewframe, framenum[0]);
    }
    else	
      jva.NPACStore.storeframe(jva.newframe, framenum[0]);		
	
    System.out.println("Decompressed.");
  }

  public static void getMBs(int framenum){

    COD = 0; CBP = 0; CBPB = 0; MODB = 0; Mode = 0;
    mvdbx = 0; mvdby = 0; last_done = 0; pCBP = 0; pCBPB = 0; pCOD = 0;
    /* number of macroblocks per picture */
    MBAmax = jva.mb_width*jva.mb_height;
    
    MBA = 0; /* macroblock address */
    jva.newgob = 0;
    
    /* mark MV's above the picture */

    for (i = 1; i < jva.tmnh.MBC+1; i++) {
      for (k = 0; k < 5; k++) {
	jva.MV[0][k][0][i] = jva.tmnh.NO_VEC;
	jva.MV[1][k][0][i] = jva.tmnh.NO_VEC;
      }
      jva.modemap[0][i] = jva.tmnh.MODE_INTRA;
    }

    /* zero MV's on the sides of the picture */
    for (i = 0; i < jva.tmnh.MBR+1; i++) {
      for (k = 0; k < 5; k++) {
	jva.MV[0][k][i][0] = 0;
	jva.MV[1][k][i][0] = 0;
	jva.MV[0][k][i][jva.tmnh.MBC+1] = 0;
	jva.MV[1][k][i][jva.tmnh.MBC+1] = 0;
      }
      jva.modemap[i][0] = jva.tmnh.MODE_INTRA;
      jva.modemap[i][jva.tmnh.MBC+1] = jva.tmnh.MODE_INTRA;
    }
    
    jva.fault = 0;
    gobheader_read = 0;

    for(;;){
      if (jva.trace != 0)
       	System.out.println("Frame " + jva.tr_framenum[0] + " MB " + MBA);
      if (resync() != 0)
	return;
    }
 
  }

  static int resync(){
    
    int res;
    
    /* This version of the decoder does not resync on every possible
       error, and it does not do all possible error checks. It is not
       difficult to make it much more error robust, but I do not think
       it is necessary to include this in the freely available
       version. */
    
    if (jva.fault != 0) {
      System.out.println("Warning: A Fault Condition Has Occurred - Resyncing");
      jva.NPACGetHdr.startcode();  /* sync on new startcode */
      jva.fault = 0;
    }

    if ((jva.NPACGetBits.showbits(22)>>6) == 0) { /* startcode */

      jva.NPACGetHdr.startcode();  
      /* in case of byte aligned start code, ie. PSTUF, GSTUF or ESTUF
	 is used */
      
      if (jva.NPACGetBits.showbits(22) == (32|jva.tmnh.SE_CODE)) { /* end of sequence */
	if (!((jva.syntax_arith_coding != 0) && (MBA < MBAmax))) {
	  return 1;
	}
      }
      else if ((jva.NPACGetBits.showbits(22) == jva.tmnh.PSC<<5) ) { /* new picture */
	if (!((jva.syntax_arith_coding != 0) && (MBA < MBAmax))) {
	  return 1;
	}
      }
      else {
	if (!((jva.syntax_arith_coding != 0) && (MBA % MBAmax != 0))) {
	  if (jva.syntax_arith_coding != 0) {   /* SAC hack to finish GOBs which   */
	    gob = (int) (jva.NPACGetBits.showbits(22) & 31); /* end with MBs coded with no bits */
	    if (gob * jva.mb_width != MBA){
	      res = finish_gob();
	      return res;
	    }
	  }

	  gob = jva.NPACGetHdr.getheader() - 1;
	  if (gob > jva.tmnh.MBR) {
	    if (jva.quiet == 0)
	      System.out.println("GN out of range\n");
	    return 1;
	  }
	  
	  /* GFID is not allowed to change unless PTYPE in picture header 
	     changes */
	  gfid = (int) jva.NPACGetBits.getbits(2);
	  /* NB: in error-prone environments the decoder can use this
	     value to determine whether a picture header where the PTYPE
	     has changed, has been lost */
	  
	  jva.quant = (int) jva.NPACGetBits.getbits(5);
	  if (jva.trace != 0)
	    System.out.println("GQUANT: " +  jva.quant);
	  xpos = 0;
	  ypos = gob;
	  MBA = ypos * jva.mb_width;
	  
	  jva.newgob = 1;
	  gobheader_read = 1;
	  if (jva.syntax_arith_coding != 0) 
	    jva.NPACSac.decoder_reset();	/* init. arithmetic decoder buffer after gob */
	}
      }
    }
    
    res = finish_gob();
    return res;
  }

  static int finish_gob(){

    int res;
    
    if(gobheader_read == 0){
      xpos = MBA%jva.mb_width;
      ypos = MBA/jva.mb_width;
      if (xpos == 0 && ypos > 0)
	jva.newgob = 0;
    }
    else 
      gobheader_read = 0;

    if (MBA>=MBAmax) 
      return 1; /* all macroblocks decoded */

    res = read_cod();
    
    return res;
  }

  static int read_cod(){

    int res;
    
    if (jva.syntax_arith_coding != 0) { 
      if (jva.pict_type == jva.tmnh.PCT_INTER) {
	COD_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_COD);
	COD = jvaind.codtab[COD_index];
	if (jva.trace != 0) {
	  System.out.println("Arithmetic Decoding Debug");
	  System.out.println("COD Index: " + COD_index + " COD: " +  COD);
	}
      }
      else
	COD = 0;  /* COD not used in I-pictures, set to zero */
    }
    else {
      if (jva.pict_type == jva.tmnh.PCT_INTER) 
	COD = (int) jva.NPACGetBits.showbits(1);
      else
	COD = 0; /* Intra picture -> not skipped */
    }
 
    if (COD == 0) {  /* COD == 0 --> not skipped */    

      if (jva.syntax_arith_coding != 0)  {
	if (jva.pict_type == jva.tmnh.PCT_INTER) {
	  MCBPC_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_MCBPC);
	  MCBPC = jvaind.mcbpctab[MCBPC_index];
	}	
	else {
	  MCBPC_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_MCBPC_intra);
	  MCBPC = jvaind.mcbpc_intratab[MCBPC_index];
	}
	if (jva.trace != 0) 
	  System.out.println("MCBPC Index: " + MCBPC_index + " MCBPC: " + MCBPC);
      }
      
      else {
	if (jva.pict_type == jva.tmnh.PCT_INTER)
	  jva.NPACGetBits.flushbits(1); /* flush COD bit */
      	if (jva.pict_type == jva.tmnh.PCT_INTRA) 
	  MCBPC = jva.NPACGetVlc.getMCBPCintra();
      	else
	  MCBPC = jva.NPACGetVlc.getMCBPC();
      }

      if (jva.fault != 0){
	res = resync(); /* !!! Goto here !!!*/
	return res;
      }

      if (MCBPC == -1) { /* stuffing */
	res = read_cod(); /* !!! Goto here to self */
	return res;
      }

      else {             /* normal MB data */
	
	Mode = MCBPC & 7;

	/* MODB and CBPB */
	if (jva.pb_frame != 0) {
	  CBPB = 0;
 	  if (jva.syntax_arith_coding != 0)  {
	    MODB_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_MODB);
	    MODB = jvaind.modb_tab[MODB_index];
	  }
	  else 
	    MODB = jva.NPACGetVlc.getMODB();
	  if (jva.trace != 0)
	    System.out.println("MODB: " + MODB);
	  if (MODB == jva.tmnh.PBMODE_CBPB_MVDB) {
	    if (jva.syntax_arith_coding != 0)  {
	      for(i=0; i<4; i++) {
		YCBPB_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_YCBPB);
		YCBPB = jvaind.ycbpb_tab[YCBPB_index];
		CBPB |= (YCBPB << (6-1-i));
	      }
	      
	      for(i=4; i<6; i++) {
		UVCBPB_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_UVCBPB);
		UVCBPB = jvaind.uvcbpb_tab[UVCBPB_index];
		CBPB |= (UVCBPB << (6-1-i));
	      }
	    }
	    else
	      CBPB = (int) jva.NPACGetBits.getbits(6);
	    if (jva.trace != 0)
	      System.out.println("CBPB = " + CBPB);
	  }
	}

	if (jva.syntax_arith_coding != 0) {

	  if (Mode == jva.tmnh.MODE_INTRA || Mode == jva.tmnh.MODE_INTRA_Q) { /* Intra */
	    CBPY_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_CBPY_intra);
	    CBPY = jvaind.cbpy_intratab[CBPY_index];
	  }
	  else {
	    CBPY_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_CBPY);
	    CBPY = jvaind.cbpytab[CBPY_index];
	
	  }
	  if (jva.trace != 0)
	    System.out.println("CBPY Index: " + CBPY_index + " CBPY " + CBPY); 

	}
	else 
	  CBPY = jva.NPACGetVlc.getCBPY();
 
	/* Decode Mode and CBP */
	
	
	if (Mode == jva.tmnh.MODE_INTRA || Mode == jva.tmnh.MODE_INTRA_Q)
	  {/* Intra */
	    if (jva.syntax_arith_coding == 0)	
	      CBPY = CBPY^15;		/* needed in huffman coding only */
	  }
	
	CBP = (CBPY << 2) | (MCBPC >> 4);
/*	System.out.println("Finished CBPY");*/
      }
      

      if (Mode == jva.tmnh.MODE_INTER4V && jva.adv_pred_mode == 0) 
	if (jva.quiet == 0)
	  System.out.println("8x8 vectors not allowed in normal prediction mode");
      /* Could set fault-flag and resync */
      
      if (Mode == jva.tmnh.MODE_INTER_Q || Mode == jva.tmnh.MODE_INTRA_Q) {
	/* Read DQUANT if necessary */
	
	if (jva.syntax_arith_coding != 0) {
	  DQUANT_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_DQUANT);
	  DQUANT = jvaind.dquanttab[DQUANT_index] - 2; 
	  jva.quant +=DQUANT;
	  if (jva.trace != 0)
	    System.out.println("DQUANT Index: " + DQUANT_index + " DQUANT " + DQUANT);
	}
	else {
	  DQUANT = (int) jva.NPACGetBits.getbits(2);
	  jva.quant += DQ_tab[DQUANT];
	  if (jva.trace != 0) {
	    System.out.print("DQUANT (");
	    jva.NPACH263Dec.printbits(DQUANT,2,2);
	    System.out.println("): " + DQUANT + " = " + DQ_tab[DQUANT]);
	  }
	}
	
	if (jva.quant > 31 || jva.quant < 1) {
	  if (jva.quiet == 0)
	    System.out.println("Quantizer out of range: clipping");
	  jva.quant = jva.mmax(1,jva.mmin(31,jva.quant));
	  /* could set fault-flag and resync here */
	}
      }
      
      /* motion vectors */
      if (Mode == jva.tmnh.MODE_INTER || Mode == jva.tmnh.MODE_INTER_Q || 
	  Mode == jva.tmnh.MODE_INTER4V || jva.pb_frame != 0) {
	
	if (Mode == jva.tmnh.MODE_INTER4V) { startmv = 1; stopmv = 4;}
	else { startmv = 0; stopmv = 0;}

	for (k = startmv; k <= stopmv; k++) {
	  if (jva.syntax_arith_coding != 0) {
	    mvx_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_MVD);
	    mvx = jvaind.mvdtab[mvx_index];
	    mvy_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_MVD);
	    mvy = jvaind.mvdtab[mvy_index];
	    if (jva.trace != 0)
	      System.out.println("mvx_index: " + mvy_index + "mvy_index " + mvx_index);
	  }
	  else {
	    mvx = jva.NPACGetVlc.getTMNMV();
	    mvy = jva.NPACGetVlc.getTMNMV();
	  }

	  pmv0 = find_pmv(xpos,ypos,k,0);
	  pmv1 = find_pmv(xpos,ypos,k,1);
/*	  System.out.println("mvx: " + mvx + " pmv0: " + pmv0 + " mvy: " + mvy + " pmv1: " + pmv1 + " xpos: " + xpos + " ypos: " + ypos + " k: " + k);*/
	  mvx = motion_decode(mvx, pmv0);	
	  mvy = motion_decode(mvy, pmv1);
	  if (jva.trace != 0) {
	    System.out.println("mvx: " +  mvx);
	    System.out.println("mvy: " +  mvy);
	  }

	  /* Check mv's to prevent seg.faults when error rate is high */
	  if (jva.mv_outside_frame == 0) {
	    if (k != 0)
	      bsize = 8;
	    else
	      bsize= 16;
	    if (k != 0)
	      offset = (((k-1)&1)<<3);
	    else
	      offset = 0;

	    /* checking only integer component */
	    if ((xpos<<4) + (mvx/2) + offset < 0 ||
		(xpos<<4) + (mvx/2) + offset > (jva.mb_width<<4) - bsize) {
	      if (jva.quiet == 0)
		System.out.println("mvx out of range: searching for sync");
	      jva.fault = 1;
	    }
	    if (k != 0)
	      offset = (((k-1)&2)<<2);
	    else
	      offset = 0;
	    
	    if ((ypos<<4) + (mvy/2) + offset < 0 ||
		(ypos<<4) + (mvy/2) + offset > (jva.mb_height<<4) - bsize) {
	      if (jva.quiet == 0)
		System.out.println("mvy out of range: searching for sync");
	      jva.fault = 1;
	    }
	  }
/*	  System.err.println("Frame " + jva.tr_framenum[0] + " k: " + k + " ypos: " + ypos + " xpos: " + xpos + " mvx: " + mvx + " mvy: " + mvy);*/
	  jva.MV[0][k][ypos+1][xpos+1] = mvx;
	  jva.MV[1][k][ypos+1][xpos+1] = mvy;
	}
	
	/* PB frame delta vectors */
	
	if (jva.pb_frame != 0) {
	  if (MODB == jva.tmnh.PBMODE_MVDB || MODB == jva.tmnh.PBMODE_CBPB_MVDB) {
	    if (jva.syntax_arith_coding != 0) {
	      mvdbx_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_MVD);
	      mvdbx = jvaind.mvdtab[mvdbx_index];
	      
	      mvdby_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_MVD);
	      mvdby = jvaind.mvdtab[mvdby_index];
	    }
	    else {
	      mvdbx = jva.NPACGetVlc.getTMNMV();
	      mvdby = jva.NPACGetVlc.getTMNMV();
	    }


	    mvdbx = motion_decode(mvdbx, 0);
	    mvdby = motion_decode(mvdby, 0);
	    /* This will not work if the PB deltas are so large they
	       require the second colums of the motion vector VLC
	       table to be used.  To fix this it is necessary to
	       calculate the MV predictor for the PB delta: TRB*MV/TRD
	       here, and use this as the second parameter to
	       motion_decode(). The B vector itself will then be
	       returned from motion_decode(). This will have to be
	       changed to the PB delta again, since it is the PB delta
	       which is used later in this program. I don't think PB
	       deltas outside the range mentioned above is useful, but
	       you never know... */

	    if (jva.trace != 0) {
	      System.out.println("MVDB x: " +  mvdbx);
	      System.out.println("MVDB y: " +  mvdby);
	    }
	  }
	  else {
	    mvdbx = 0; 
	    mvdby = 0;
	  }
	}
      }
      
      if (jva.fault != 0){
	res =  resync();
	return res;
      }
    }

    else { /* COD == 1 --> skipped MB */
      if (MBA>=MBAmax)
	return 1; /* !!! Return here out of for loop !!!!*/
      if (jva.syntax_arith_coding == 0)
	if (jva.pict_type == jva.tmnh.PCT_INTER)
	  jva.NPACGetBits.flushbits(1);

      Mode = jva.tmnh.MODE_INTER;

      /* Reset CBP */
      CBP = CBPB = 0;
      /* reset motion vectors */
      jva.MV[0][0][ypos+1][xpos+1] = 0;
      jva.MV[1][0][ypos+1][xpos+1] = 0;
      mvdbx = 0;
      mvdby = 0;
    }

    /* Store Mode*/
    jva.modemap[ypos+1][xpos+1] = Mode;
    
    if (Mode == jva.tmnh.MODE_INTRA || Mode == jva.tmnh.MODE_INTRA_Q) 
      if (jva.pb_frame == 0)
	jva.MV[0][0][ypos+1][xpos+1]=jva.MV[1][0][ypos+1][xpos+1] = 0;
    

    res = reconstruct_mb();
    return res;
  }

  static int reconstruct_mb(){

    int res;
    int temp;
    /* pixel coordinates of top left corner of current macroblock */
    /* one delayed because of OBMC */
    if (xpos > 0) {
      bx = 16*(xpos-1);
      by = 16*ypos;
    }
    else {
      bx = jva.coded_picture_width-16;
      by = 16*(ypos-1);
    }
    
    if (MBA > 0) {

      Mode = jva.modemap[by/16+1][bx/16+1];
      
      /* forward motion compensation for B-frame */
      if (jva.pb_frame != 0)
	jva.NPACRecon.reconstruct(bx,by,0,pmvdbx,pmvdby);
      
      /* motion compensation for P-frame */
      if (Mode == jva.tmnh.MODE_INTER || Mode == jva.tmnh.MODE_INTER_Q 
	  || Mode == jva.tmnh.MODE_INTER4V)
	jva.NPACRecon.reconstruct(bx,by,1,0,0);
    
      /* copy or add block data into P-picture */
      for (comp=0; comp<jva.blk_cnt; comp++) {
	/* inverse DCT */
	if (Mode == jva.tmnh.MODE_INTRA || Mode == jva.tmnh.MODE_INTRA_Q) {
	  if (jva.refidct != 0)
	    jva.NPACIdctRef.idctref(jva.ld.block[comp]);
	  else
	    jva.NPACIdct.idct(jva.ld.block[comp]);
	  addblock(comp,bx,by,0);
	}
	else{
	  temp = pCBP & (1<<(jva.blk_cnt-1-comp));
	  if ( temp != 0 ) {
	    /* No need to to do this for blocks with no coeffs */
	    if (jva.refidct != 0)
	      jva.NPACIdctRef.idctref(jva.ld.block[comp]);
	    else
	      jva.NPACIdct.idct(jva.ld.block[comp]);
	    addblock(comp,bx,by,1);
	  }
	}
      }
      
      if (jva.pb_frame != 0) {
	/* add block data into B-picture */
	for (comp = 6; comp<jva.blk_cnt+6; comp++) {
	  if (pCOD == 0 || jva.adv_pred_mode != 0)
	    reconblock_b(comp-6,bx,by,Mode,pmvdbx,pmvdby);
	  temp = (pCBPB & (1<<(jva.blk_cnt-1-comp%6))); 
	  if ( temp != 0 ) {
	    if (jva.refidct != 0)
	      jva.NPACIdctRef.idctref(jva.ld.block[comp]);
	    else
	      jva.NPACIdct.idct(jva.ld.block[comp]);
	    addblock(comp,bx,by,1);
	  }
	}
      }
      
    } /* end if (MBA > 0) */
  
    if (COD == 0) {

      Mode = jva.modemap[ypos+1][xpos+1];

      /* decode blocks */
      for (comp=0; comp<jva.blk_cnt; comp++) {

        clearblock(comp);
	if (Mode == jva.tmnh.MODE_INTRA || 
	    Mode == jva.tmnh.MODE_INTRA_Q) { /* Intra */
	  bp = jva.ld.block[comp];
	  if(jva.syntax_arith_coding != 0) {
	    INTRADC_index = jva.NPACSac.decode_a_symbol(jvasach.cumf_INTRADC);
	    bp[0] = (short) (jvaind.intradctab[INTRADC_index]);
	    if (jva.trace != 0)
	      System.out.println("INTRADC Index: " + INTRADC_index + " INTRADC: " + bp[0]);
	  }
	  else {
	    bp[0] = (short) jva.NPACGetBits.getbits(8);
	    if (jva.trace != 0) {
	      System.out.print("DC[" + comp + "]: (");
	      jva.NPACH263Dec.printbits((long)bp[0],8,8);
	      System.out.println("): " + (int)bp[0]);
	    }
	  }

	  if (bp[0] == 128)
	    if (jva.quiet == 0)
	      System.err.println("Illegal DC-coeff: 1000000");
	  if (bp[0] == 255)  /* Spec. in H.26P, not in TMN4 */
	    bp[0] = 128;
	  bp[0] *= 8; /* Iquant */
	  temp = (CBP & (1<<(jva.blk_cnt-1-comp))); 
	  if ( temp != 0 ) {
	    if (jva.syntax_arith_coding == 0)
	      jva.NPACGetBlk.getblock(comp,0);
	    else 
	      jva.NPACGetBlk.get_sac_block(comp,0);
	  }
	}
	else { /* Inter */
	  temp = (CBP & (1<<(jva.blk_cnt-1-comp))); 
	  if ( temp != 0 ) {
	    if (jva.syntax_arith_coding == 0)
	      jva.NPACGetBlk.getblock(comp,1);
	    else
	      jva.NPACGetBlk.get_sac_block(comp,1);
	  }
	  
	}
	if (jva.fault != 0){
	  res = resync();
	  return res;
	}
      }

      /* Decode B blocks */
      if (jva.pb_frame != 0) {
	for (comp=6; comp<jva.blk_cnt+6; comp++) {
	  clearblock(comp);
	  temp = (CBPB & (1<<(jva.blk_cnt-1-comp%6))); 
	  if ( temp != 0 ) {
	    if (jva.syntax_arith_coding == 0)
	      jva.NPACGetBlk.getblock(comp,1);
	    else
	      jva.NPACGetBlk.get_sac_block(comp,1);
	  }
	  if (jva.fault != 0){
	    res = resync();
	    return res;
	  }
	}
      }
      
    }
    
    /* advance to next macroblock */
    MBA++;

    pCBP = CBP; pCBPB = CBPB; pCOD = COD;
    pmvdbx = mvdbx; pmvdby = mvdby;

    if (MBA >= MBAmax && last_done == 0) {
      COD = 1;
      xpos = 0;
      ypos++;
      last_done = 1;
      res = reconstruct_mb();
      return res;
    }
    
    return 0;

  }

  
  public static void clearblock(int comp){
    
    short bp[];
    int i;
    
    bp = jva.ld.block[comp];
    
    for (i=0; i<jva.ld.block[comp].length;i++)
      {
	bp[i] = 0;
      }
  }

  public static void addblock(int comp,int bx,int by,int addflag){

    int cc,i, iincr, P = 1;
    int rfp[];
    short bp[];
    int offset;
    int offsetb = 0;
    
    bp = jva.ld.block[comp];
    
    if (comp >= 6) {
      /* This is a component for B-frame forward prediction */
      P = 0;
      addflag = 1;
      comp -= 6;
    }
    
    cc = (comp<4) ? 0 : (comp&1)+1; /* color component index */
    
    if (cc==0) {
      /* luminance */
      
      /* frame DCT coding */
      if (P != 0){
	offset = jva.coded_picture_width*(by+((comp&2)<<2)) + bx + ((comp&1)<<3);
	rfp = jva.newframe[0];
/*	System.out.println("New frame chosen");*/
	}
      else{
	offset = jva.coded_picture_width*(by+((comp&2)<<2)) + bx + ((comp&1)<<3);
	rfp = jva.bframe[0];
/*	System.out.println("Bframe chosen");*/
      }
      iincr = jva.coded_picture_width;
    }
    else {
      /* chrominance */
      
      /* scale coordinates */
      bx >>= 1;
      by >>= 1;
      /* frame DCT coding */
      if (P != 0){
	offset = jva.chrom_width*by + bx;
	rfp = jva.newframe[cc];
      }
      else{
	offset = jva.chrom_width*by + bx;
	rfp = jva.bframe[cc];
      }
      iincr = jva.chrom_width;
    }
    
/*    System.out.println("Addflag is " + addflag);
    System.out.println("IINCR IS " + iincr + "offset is " + offset);*/

    if (addflag != 0) {
      for (i=0; i<8; i++) {
	rfp[0 + offset] = jva.clp[bp[0 + offsetb]+rfp[0 + offset] + 384];
	rfp[1 + offset] = jva.clp[bp[1 + offsetb]+rfp[1 + offset] + 384];
	rfp[2 + offset] = jva.clp[bp[2 + offsetb]+rfp[2 + offset] + 384];
	rfp[3 + offset] = jva.clp[bp[3 + offsetb]+rfp[3 + offset] + 384];
	rfp[4 + offset] = jva.clp[bp[4 + offsetb]+rfp[4 + offset] + 384];
	rfp[5 + offset] = jva.clp[bp[5 + offsetb]+rfp[5 + offset] + 384];
	rfp[6 + offset] = jva.clp[bp[6 + offsetb]+rfp[6 + offset] + 384];
	rfp[7 + offset] = jva.clp[bp[7 + offsetb]+rfp[7 + offset] + 384];
	offsetb += 8;
	offset+= iincr;
      }
    }
    else  {
      for (i=0; i<8; i++) {
	rfp[0 + offset] = jva.clp[bp[0 + offsetb] + 384];
	rfp[1 + offset] = jva.clp[bp[1 + offsetb] + 384];
	rfp[2 + offset] = jva.clp[bp[2 + offsetb] + 384];
	rfp[3 + offset] = jva.clp[bp[3 + offsetb] + 384];
	rfp[4 + offset] = jva.clp[bp[4 + offsetb] + 384];
	rfp[5 + offset] = jva.clp[bp[5 + offsetb] + 384];
	rfp[6 + offset] = jva.clp[bp[6 + offsetb] + 384];
	rfp[7 + offset] = jva.clp[bp[7 + offsetb] + 384];
	offsetb += 8;
	offset += iincr;
      }
    }
  }
  
  public static void reconblock_b(int comp,int bx,int by,int mode,int bdx,int bdy){
    
    int cc,i,j,k, ii;
    int bfr[], ffr[];
    int obfr, offr;
    int BMVx, BMVy;
    int xa[],xb[],ya[],yb[],x,y,xvec,yvec,mvx,mvy;
    int xint,xhalf,yint,yhalf,pel;
    
    xa = new int[1];
    ya = new int[1];
    xb = new int[1];
    yb = new int[1];
    x = bx/16+1;y=by/16+1;
    
    if (mode == jva.tmnh.MODE_INTER4V) {
      if (comp < 4) {
	/* luma */
	mvx = jva.MV[0][comp+1][y][x];
	mvy = jva.MV[1][comp+1][y][x];
	BMVx = (bdx == 0 ? (jva.trb-jva.trd)* mvx/jva.trd : jva.trb * mvx/jva.trd + bdx - mvx);
	BMVy = (bdy == 0 ? (jva.trb-jva.trd)* mvy/jva.trd : jva.trb * mvy/jva.trd + bdy - mvy);
      }
      else {
	/* chroma */
	xvec = yvec = 0;
	for (k = 1; k <= 4; k++) {
	  mvx = jva.MV[0][k][y][x];
	  mvy = jva.MV[1][k][y][x];
	  xvec += (bdx == 0 ? (jva.trb-jva.trd)* mvx/jva.trd : jva.trb * mvx/jva.trd + bdx - mvx);
	  yvec += (bdy == 0 ? (jva.trb-jva.trd)* mvy/jva.trd : jva.trb * mvy/jva.trd + bdy - mvy);
	}
	
	/* chroma rounding (table 16/H.263) */
	BMVx = jva.sign(xvec)*(jva.roundtab[java.lang.Math.abs(xvec)%16] + (java.lang.Math.abs(xvec)/16)*2);
	BMVy = jva.sign(yvec)*(jva.roundtab[java.lang.Math.abs(yvec)%16] + (java.lang.Math.abs(yvec)/16)*2);
      }
    }
    else {
      if (comp < 4) {
	/* luma */
	mvx = jva.MV[0][0][y][x];
	mvy = jva.MV[1][0][y][x];
	BMVx = (bdx == 0 ? (jva.trb-jva.trd)* mvx/jva.trd : jva.trb * mvx/jva.trd + bdx - mvx);
	BMVy = (bdy == 0 ? (jva.trb-jva.trd)* mvy/jva.trd : jva.trb * mvy/jva.trd + bdy - mvy);
      }
      else {
	/* chroma */
	mvx = jva.MV[0][0][y][x];
	mvy = jva.MV[1][0][y][x];
	xvec = (bdx == 0 ? (jva.trb-jva.trd)* mvx/jva.trd : jva.trb * mvx/jva.trd + bdx - mvx);
	yvec = (bdy == 0 ? (jva.trb-jva.trd)* mvy/jva.trd : jva.trb * mvy/jva.trd + bdy - mvy);
	xvec *= 4;
	yvec *= 4;
	
	/* chroma rounding (table 16/H.263) */
	BMVx = jva.sign(xvec)*(jva.roundtab[java.lang.Math.abs(xvec)%16] + (java.lang.Math.abs(xvec)/16)*2);
	BMVy = jva.sign(yvec)*(jva.roundtab[java.lang.Math.abs(yvec)%16] + (java.lang.Math.abs(yvec)/16)*2);
      }
    }
    
    cc = (comp<4) ? 0 : (comp&1)+1; /* color component index */
    
    if (cc==0) {
      /* luminance */
      find_bidir_limits(BMVx,xa,xb,comp&1);
      find_bidir_limits(BMVy,ya,yb,(comp&2)>>1);
      obfr = jva.coded_picture_width*(by+((comp&2)<<2)) + bx + ((comp&1)<<3);
      bfr = jva.bframe[0];
      offr = jva.coded_picture_width*(by+((comp&2)<<2)) + bx + ((comp&1)<<3);
      ffr = jva.newframe[0];
      ii = jva.coded_picture_width;
    }
    else {
      /* chrominance */
      /* scale coordinates and vectors*/
      bx >>= 1;
      by >>= 1;
      
      find_bidir_chroma_limits(BMVx,xa,xb);
      find_bidir_chroma_limits(BMVy,ya,yb);
      
      bfr = jva.bframe[cc];      
      ffr = jva.newframe[cc];    
      obfr = jva.chrom_width*(by+((comp&2)<<2)) + bx + (comp&8);
      offr = jva.chrom_width*(by+((comp&2)<<2)) + bx + (comp&8);
      ii = jva.chrom_width;
    }
    
    xint = BMVx>>1;
    xhalf = BMVx - 2*xint;
    yint = BMVy>>1;
    yhalf = BMVy - 2*yint;
    
    offr += xint + (yint+ya[0])*ii;
    obfr += ya[0]*ii;
    
    if (xhalf == 0 && yhalf == 0) {
      for (j = ya[0]; j < yb[0]; j++) {
	for (i = xa[0]; i < xb[0]; i++) {
	  pel = ffr[i + offr];
	  bfr[i + obfr] = ((int)(pel + bfr[i + obfr]))>>1;
	}
	obfr += ii;
	offr += ii;
      }
    }
    else if (xhalf != 0 && yhalf == 0) {
      for (j = ya[0]; j < yb[0]; j++) {
	for (i = xa[0]; i < xb[0]; i++) {
	  pel = ((int)(ffr[i + offr]+ffr[i+1 + offr]+1))>>1;
	  bfr[i + obfr] = ((int)(pel + bfr[i + obfr]))>>1;
	}
	obfr += ii;
	offr += ii;
      }
    }
    else if (xhalf == 0 && yhalf != 0) {
      for (j = ya[0]; j < yb[0]; j++) {
	for (i = xa[0]; i < xb[0]; i++) {
	  pel = ((int)(ffr[i + offr]+ffr[ii+i + offr]+1))>>1;
	  bfr[i + obfr] = ((int)(pel + bfr[i + obfr]))>>1;
	}
	obfr += ii;
	offr += ii;
      }
    }
    else { /* if (xhalf && yhalf) */
      for (j = ya[0]; j < yb[0]; j++) {
	for (i = xa[0]; i < xb[0]; i++) {
	  pel = ((int)(ffr[i + offr]+ffr[i+1 + offr]+ffr[ii+i + offr]+ffr[ii+i+1 + offr]+2))>>2;
	  bfr[i + obfr] = ((int)(pel + bfr[i + obfr]))>>1;
	}
	obfr += ii;
	offr += ii;
      }
    }
    return;
    
  }

  public static int motion_decode(int vec,int pmv){

    if (vec > 31) vec -= 64;
    vec += pmv;
    if (jva.long_vectors == 0) {
      if (vec > 31)
	vec -= 64;
      if (vec < -32)
	vec += 64;
    }
    else {
      if (pmv < -31 && vec < -63)
	vec += 64;
      if (pmv > 32 && vec > 63)
	vec -= 64;
    }
    return vec;
  }
  
  public static int find_pmv(int x,int y,int block,int comp){

    int p1,p2,p3;
    int xin1 = 0,xin2 = 0,xin3 = 0;
    int yin1 = 0,yin2 = 0,yin3 = 0;
    int vec1 = 0,vec2 = 0,vec3 = 0;
    int l8,o8,or8;
    
    x++;y++;
    
    l8 = (jva.modemap[y][x-1] == jva.tmnh.MODE_INTER4V ? 1 : 0);
    o8 =  (jva.modemap[y-1][x] == jva.tmnh.MODE_INTER4V ? 1 : 0);
    or8 = (jva.modemap[y-1][x+1] == jva.tmnh.MODE_INTER4V ? 1 : 0);
    
    switch (block) {
    case 0:
      if (l8 != 0) vec1 = 2; else vec1 = 0;
      yin1 = y  ; xin1 = x-1;
      if (o8 != 0) vec2 = 3; else vec2 = 0;
      yin2 = y-1; xin2 = x;
      if (or8 != 0) vec3 = 3; else vec3 = 0;
      yin3 = y-1; xin3 = x+1;
      break;
    case 1:
      if (l8 != 0) vec1 = 2; else vec1 = 0;
      yin1 = y  ; xin1 = x-1;
      if (o8 != 0) vec2 = 3; else vec2 = 0;
      yin2 = y-1; xin2 = x;
      if (or8 != 0) vec3 = 3; else vec3 = 0;
      yin3 = y-1; xin3 = x+1;
      break;
    case 2:
      vec1 = 1            ; yin1 = y  ; xin1 = x;
      if (o8 != 0) vec2 = 4; else vec2 = 0;
      yin2 = y-1; xin2 = x;
      if (or8 != 0) vec3 = 3; else vec3 = 0;
      yin3 = y-1; xin3 = x+1;
      break;
    case 3:
      if (l8 != 0) vec1 = 4; else vec1 = 0;
      yin1 = y  ; xin1 = x-1;
      vec2 = 1            ; yin2 = y  ; xin2 = x;
      vec3 = 2            ; yin3 = y  ; xin3 = x;
      break;
    case 4:
      vec1 = 3            ; yin1 = y  ; xin1 = x;
      vec2 = 1            ; yin2 = y  ; xin2 = x;
      vec3 = 2            ; yin3 = y  ; xin3 = x;
      break;
    default:
      System.err.println("Illegal block number in find_pmv (getpic.c)");
      System.exit(1);
      break;
    }

/*    System.out.println("vec1: " + vec1 + " vec2: " + vec2 + " vec3: " + vec3);
    System.out.println("yin1: " + yin1 + " yin2: " + yin2 + " yin3: " + yin3);
    System.out.println("xin1: " + xin1 + " xin2: " + xin2 + " xin3: " + xin3);
*/
    p1 = jva.MV[comp][vec1][yin1][xin1];
    p2 = jva.MV[comp][vec2][yin2][xin2];
    p3 = jva.MV[comp][vec3][yin3][xin3];
/*    System.out.println("p1: " + p1 + " p2: " + p2 + " p3: " + p3);*/
    if (jva.newgob != 0 && (block == 0 || block == 1 || block == 2))
      p2 = jva.tmnh.NO_VEC;
    
    if (p2 == jva.tmnh.NO_VEC) { p2 = p3 = p1; }
    
    return (int) (p1+p2+p3 - jva.mmax(p1,jva.mmax(p2,p3)) - jva.mmin(p1,jva.mmin(p2,p3)));

  }

  public static void find_bidir_limits(int vec,int start[],
				       int stop[],int nhv){

    /* limits taken from C loop in section G5 in H.263 */
    start[0] = jva.mmax(0,(-vec+1)/2 - nhv*8);
    stop[0] = jva.mmin(7,15-(vec+1)/2 - nhv*8);
  
    stop[0]++;
    
  }

  public static void find_bidir_chroma_limits(int vec,int start[],int stop[]){

    /* limits taken from C loop in section G5 in H.263 */
    start[0] = jva.mmax(0,(-vec+1)/2);
    stop[0] = jva.mmin(7,7-(vec+1)/2);
   
    stop[0]++;
    return;
  }

  public static void make_edge_image(int src[],int[] dst, int dstoff,
				     int width,int height,int edge){

    int i,j;
    int p1[],p2[],p3[],p4[];
    int o1[],o2[],o3[],o4[];
    int sp1, sp2, sp3, sp4;
    int so1, so2, so3, so4;
    
    /* center image */
    p1 = dst;
    o1 = src;
    sp1 = dstoff; so1 = 0;
    for (j = 0; j < height;j++) {
      for (i = 0; i < width; i++) {
	p1[sp1 + i] = o1[so1 + i];
      }
      sp1 += width + (edge<<1);
      so1 += width;
    }
    
    /* left and right edges */
    p1 = dst;
    o1 = src;
    sp1 = dstoff - 1; so1 = 0;

    for (j = 0; j < height;j++) {
      for (i = 0; i < edge; i++) {
	p1[sp1 - i] = o1[so1];
	p1[sp1 + width + i + 1] = o1[so1 + width - 1];
      }
      sp1 += width + (edge<<1);
      so1 += width;
    }    
    
    /* top and bottom edges */
    p1 = dst; sp1 = dstoff;
    p2 = dst; sp2 = dstoff + (width + (edge<<1))*(height-1);
    o1 = src; so1 = 0;
    o2 = src; so2 = width*(height-1);
    for (j = 0; j < edge;j++) {
      sp1 = sp1 - (width + (edge<<1));
      sp2 = sp2 + (width + (edge<<1));
      for (i = 0; i < width; i++) {
	p1[sp1 + i] = o1[so1 + i];
	p2[sp2 + i] = o2[so2 + i];
      }
    }    
    
    /* corners */
    p1 = dst; sp1 = dstoff - (width+(edge<<1)) - 1; /* !!! DONE TILL HERE ONLY!! */
    p2 = dst; sp2 = sp1 + width + 1;
    p3 = dst; sp3 = dstoff + ((width+(edge<<1))*(height)-1);
    p4 = dst; sp4 = sp3 + width + 1;
    
    o1 = src; so1 = 0;
    o2 = src; so2 = so1 + width - 1;
    o3 = src; so3 = width*(height-1);
    o4 = src; so4 = so3 + width - 1;
    for (j = 0; j < edge; j++) {
      for (i = 0; i < edge; i++) {
	p1[sp1 - i] = o1[so1];
	p2[sp2 + i] = o2[so2];
	p3[sp3 - i] = o3[so3];
	p4[sp4 + i] = o4[so4];
      }
      sp1 = sp1 - (width + (edge<<1));
      sp2 = sp2 - (width + (edge<<1));
      sp3 = sp3 + width + (edge<<1);
      sp4 = sp4 + width + (edge<<1);
    }
  }

  public static void interpolate_image(int in[],int out[],
				       int width,int height){
    
    int x,xx,y,w2;
    int pp[], ii[];
    int op, oi;
    
    w2 = 2*width;
    
    /* Horizontally */
    pp = out;
    ii = in;
    op = 0; oi = 0;
    for (y = 0; y < height-1; y++) {
      for (x = 0,xx=0; x < width-1; x++,xx+=2) {
	pp[xx + op] = ii[x + oi];
	pp[xx + 1 + op] = (int) (((long) (ii[x + oi]  + ii[x + 1 + oi]))>>1);
	pp[w2 + xx + op] = (int) (((long) (ii[x + oi] + ii[x + width + oi]))>>1);
	pp[w2 + xx + 1 + op] = (int) (((long) (ii[x + oi] + ii[x + 1 + oi] + ii[x + width + oi] + ii[x + width + 1 + oi]))>>2);
      }
      
      pp[w2 - 2 + op] = ii[width - 1 + oi];
      pp[w2 - 1 + op] = ii[width - 1 + oi];
      pp[w2 + w2 - 2 + op] = ii[width + width - 1 + oi];
      pp[w2 + w2 - 1 + op] = ii[width + width - 1 + oi];
      
      op += w2 << 1;
      oi += width;
    }
    
    /* last lines */
    for (x = 0,xx=0; x < width-1; x++,xx+=2) {
      pp[xx + op] = ii[x + oi];
      pp[xx + 1 + op] = (int) (((long) (ii[x + oi] + ii[x + 1 + oi] + 1))>>1);
      pp[w2 + xx + op] = ii[x + oi];
      pp[w2 + xx + 1] = (int) (((long) (ii[x + oi] + ii[x + 1 + oi] + 1)) >> 1);
    }
    
    /* bottom right corner pels */
    pp[((width << 1) - 2) + op] = ii[width - 1 + oi];
    pp[(width << 1) - 1 + op] = ii[width - 1 + oi];
    pp[((width << 2) - 2) + op] = ii[width - 1 + oi];
    pp[(width << 2) - 1 + op] = ii[width - 1 + oi];
        
    return;

  }
  
  
}
