
import java.lang.*;

public class getvlch{
  
  public static vlctabh TMNMVtab0[];
  public static vlctabh TMNMVtab1[];
  public static vlctabh TMNMVtab2[];
  public static vlctabh MCBPCtab[];
  public static vlctabh MCBPCtabintra[];
  public static vlctabh CBPYtab[];
  public static vlctabh DCT3Dtab0[];
  public static vlctabh DCT3Dtab1[];
  public static vlctabh DCT3Dtab2[];

  public static void initArrays(){

    initTMNMV0();
    initTMNMV1();
    initTMNMV2();
    initMCBPCt();
    initMCBPCtintra();
    initCBPY();
    initDCT3D0();
    initDCT3D1();
    initDCT3D2();
      
  }


  static void initTMNMV0(){

    TMNMVtab0 = new vlctabh[14];

    for (int i = 0; i < 14; i++)
      TMNMVtab0[i] = new vlctabh();
    
    TMNMVtab0[0].val = 3; TMNMVtab0[0].len = 4;
    TMNMVtab0[1].val = 61; TMNMVtab0[1].len = 4;
    TMNMVtab0[2].val = 2; TMNMVtab0[2].len = 3;
    TMNMVtab0[3].val = 2; TMNMVtab0[3].len = 3;
    TMNMVtab0[4].val = 62; TMNMVtab0[4].len = 3;
    TMNMVtab0[5].val = 62; TMNMVtab0[5].len = 3;
    TMNMVtab0[6].val = 1; TMNMVtab0[6].len = 2;
    TMNMVtab0[7].val = 1; TMNMVtab0[7].len = 2;
    TMNMVtab0[8].val = 1; TMNMVtab0[8].len = 2;
    TMNMVtab0[9].val = 1; TMNMVtab0[9].len = 2;
    TMNMVtab0[10].val = 63; TMNMVtab0[10].len = 2;
    TMNMVtab0[11].val = 63; TMNMVtab0[11].len = 2;
    TMNMVtab0[12].val = 63; TMNMVtab0[12].len = 2;
    TMNMVtab0[13].val = 63; TMNMVtab0[13].len = 2;
  }


  static void initTMNMV1(){

    int x;

    TMNMVtab1 = new vlctabh[96];

    for (int i = 0; i < 96; i++)
      TMNMVtab1[i] = new vlctabh();
    
    TMNMVtab1[0].val = 12; TMNMVtab1[0].len = 10;
    TMNMVtab1[1].val = 52; TMNMVtab1[1].len = 10;
    TMNMVtab1[2].val = 11; TMNMVtab1[2].len = 10;
    TMNMVtab1[3].val = 53; TMNMVtab1[3].len = 10;
    TMNMVtab1[4].val = 10; TMNMVtab1[4].len = 9;
    TMNMVtab1[5].val = 10; TMNMVtab1[5].len = 9;
    TMNMVtab1[6].val = 54; TMNMVtab1[6].len = 9;
    TMNMVtab1[7].val = 54; TMNMVtab1[7].len = 9;
    TMNMVtab1[8].val = 9; TMNMVtab1[8].len = 9;
    TMNMVtab1[9].val = 9; TMNMVtab1[9].len = 9;
    TMNMVtab1[10].val = 55; TMNMVtab1[10].len = 9;
    TMNMVtab1[11].val = 55; TMNMVtab1[11].len = 9;
    TMNMVtab1[12].val = 8; TMNMVtab1[12].len = 9;
    TMNMVtab1[13].val = 8; TMNMVtab1[13].len = 9;
    TMNMVtab1[14].val = 56; TMNMVtab1[14].len = 9;
    TMNMVtab1[15].val = 56; TMNMVtab1[15].len = 9;
    TMNMVtab1[16].val = 7; TMNMVtab1[16].len = 7;
    TMNMVtab1[17].val = 7; TMNMVtab1[17].len = 7;
    TMNMVtab1[18].val = 7; TMNMVtab1[18].len = 7;
    TMNMVtab1[19].val = 7; TMNMVtab1[19].len = 7;
    TMNMVtab1[20].val = 7; TMNMVtab1[20].len = 7;
    TMNMVtab1[21].val = 7; TMNMVtab1[21].len = 7;
    TMNMVtab1[22].val = 7; TMNMVtab1[22].len = 7;
    TMNMVtab1[23].val = 7; TMNMVtab1[23].len = 7;
    TMNMVtab1[24].val = 57; TMNMVtab1[24].len = 7;
    TMNMVtab1[25].val = 57; TMNMVtab1[25].len = 7;
    TMNMVtab1[26].val = 57; TMNMVtab1[26].len = 7;
    TMNMVtab1[27].val = 57; TMNMVtab1[27].len = 7;
    TMNMVtab1[28].val = 57; TMNMVtab1[28].len = 7;
    TMNMVtab1[29].val = 57; TMNMVtab1[29].len = 7;
    TMNMVtab1[30].val = 57; TMNMVtab1[30].len = 7;
    TMNMVtab1[31].val = 57; TMNMVtab1[31].len = 7;
    TMNMVtab1[32].val = 6; TMNMVtab1[32].len = 7;
    TMNMVtab1[33].val = 6; TMNMVtab1[33].len = 7;
    TMNMVtab1[34].val = 6; TMNMVtab1[34].len = 7;
    TMNMVtab1[35].val = 6; TMNMVtab1[35].len = 7;
    TMNMVtab1[36].val = 6; TMNMVtab1[36].len = 7;
    TMNMVtab1[37].val = 6; TMNMVtab1[37].len = 7;
    TMNMVtab1[38].val = 6; TMNMVtab1[38].len = 7;
    TMNMVtab1[39].val = 6; TMNMVtab1[39].len = 7;
    TMNMVtab1[40].val = 58; TMNMVtab1[40].len = 7;
    TMNMVtab1[41].val = 58; TMNMVtab1[41].len = 7;
    TMNMVtab1[42].val = 58; TMNMVtab1[42].len = 7;
    TMNMVtab1[43].val = 58; TMNMVtab1[43].len = 7;
    TMNMVtab1[44].val = 58; TMNMVtab1[44].len = 7;
    TMNMVtab1[45].val = 58; TMNMVtab1[45].len = 7;
    TMNMVtab1[46].val = 58; TMNMVtab1[46].len = 7;
    TMNMVtab1[47].val = 58; TMNMVtab1[47].len = 7;
    TMNMVtab1[48].val = 5; TMNMVtab1[48].len = 7;
    TMNMVtab1[49].val = 5; TMNMVtab1[49].len = 7;
    TMNMVtab1[50].val = 5; TMNMVtab1[50].len = 7;
    TMNMVtab1[51].val = 5; TMNMVtab1[51].len = 7;
    TMNMVtab1[52].val = 5; TMNMVtab1[52].len = 7;
    TMNMVtab1[53].val = 5; TMNMVtab1[53].len = 7;
    TMNMVtab1[54].val = 5; TMNMVtab1[54].len = 7;
    TMNMVtab1[55].val = 5; TMNMVtab1[55].len = 7;
    TMNMVtab1[56].val = 59; TMNMVtab1[56].len = 7;
    TMNMVtab1[57].val = 59; TMNMVtab1[57].len = 7;
    TMNMVtab1[58].val = 59; TMNMVtab1[58].len = 7;
    TMNMVtab1[59].val = 59; TMNMVtab1[59].len = 7;
    TMNMVtab1[60].val = 59; TMNMVtab1[60].len = 7;
    TMNMVtab1[61].val = 59; TMNMVtab1[61].len = 7;
    TMNMVtab1[62].val = 59; TMNMVtab1[62].len = 7;
    TMNMVtab1[63].val = 59; TMNMVtab1[63].len = 7;
    TMNMVtab1[64].val = 4; TMNMVtab1[64].len = 6;
    TMNMVtab1[65].val = 4; TMNMVtab1[65].len = 6;
    TMNMVtab1[66].val = 4; TMNMVtab1[66].len = 6;
    TMNMVtab1[67].val = 4; TMNMVtab1[67].len = 6;
    TMNMVtab1[68].val = 4; TMNMVtab1[68].len = 6;
    TMNMVtab1[69].val = 4; TMNMVtab1[69].len = 6;
    TMNMVtab1[70].val = 4; TMNMVtab1[70].len = 6;
    TMNMVtab1[71].val = 4; TMNMVtab1[71].len = 6;
    TMNMVtab1[72].val = 4; TMNMVtab1[72].len = 6;
    TMNMVtab1[73].val = 4; TMNMVtab1[73].len = 6;
    TMNMVtab1[74].val = 4; TMNMVtab1[74].len = 6;
    TMNMVtab1[75].val = 4; TMNMVtab1[75].len = 6;
    TMNMVtab1[76].val = 4; TMNMVtab1[76].len = 6;
    TMNMVtab1[77].val = 4; TMNMVtab1[77].len = 6;
    TMNMVtab1[78].val = 4; TMNMVtab1[78].len = 6;
    TMNMVtab1[79].val = 4; TMNMVtab1[79].len = 6;
    TMNMVtab1[80].val = 60; TMNMVtab1[80].len = 6;
    TMNMVtab1[81].val = 60; TMNMVtab1[81].len = 6;
    TMNMVtab1[82].val = 60; TMNMVtab1[82].len = 6;
    TMNMVtab1[83].val = 60; TMNMVtab1[83].len = 6;
    TMNMVtab1[84].val = 60; TMNMVtab1[84].len = 6;
    TMNMVtab1[85].val = 60; TMNMVtab1[85].len = 6;
    TMNMVtab1[86].val = 60; TMNMVtab1[86].len = 6;
    TMNMVtab1[87].val = 60; TMNMVtab1[87].len = 6;
    TMNMVtab1[88].val = 60; TMNMVtab1[88].len = 6;
    TMNMVtab1[89].val = 60; TMNMVtab1[89].len = 6;
    TMNMVtab1[90].val = 60; TMNMVtab1[90].len = 6;
    TMNMVtab1[91].val = 60; TMNMVtab1[91].len = 6;
    TMNMVtab1[92].val = 60; TMNMVtab1[92].len = 6;
    TMNMVtab1[93].val = 60; TMNMVtab1[93].len = 6;
    TMNMVtab1[94].val = 60; TMNMVtab1[94].len = 6;
    TMNMVtab1[95].val = 60; TMNMVtab1[95].len = 6;
    
  }

  static void initTMNMV2(){

    int x;

    TMNMVtab2 = new vlctabh[123];

    for (int i = 0; i < 123; i++)
      TMNMVtab2[i] = new vlctabh();
    
    TMNMVtab2[0].val = 32; TMNMVtab2[0].len = 12;
    TMNMVtab2[1].val = 31; TMNMVtab2[1].len = 12;
    TMNMVtab2[2].val = 33; TMNMVtab2[2].len = 12;
    TMNMVtab2[3].val = 30; TMNMVtab2[3].len = 11;
    TMNMVtab2[4].val = 30; TMNMVtab2[4].len = 11;
    TMNMVtab2[5].val = 34; TMNMVtab2[5].len = 11;
    TMNMVtab2[6].val = 34; TMNMVtab2[6].len = 11;
    TMNMVtab2[7].val = 29; TMNMVtab2[7].len = 11;
    TMNMVtab2[8].val = 29; TMNMVtab2[8].len = 11;
    TMNMVtab2[9].val = 35; TMNMVtab2[9].len = 11;
    TMNMVtab2[10].val = 35; TMNMVtab2[10].len = 11;
    TMNMVtab2[11].val = 28; TMNMVtab2[11].len = 11;
    TMNMVtab2[12].val = 28; TMNMVtab2[12].len = 11;
    TMNMVtab2[13].val = 36; TMNMVtab2[13].len = 11;
    TMNMVtab2[14].val = 36; TMNMVtab2[14].len = 11;
    TMNMVtab2[15].val = 27; TMNMVtab2[15].len = 11;
    TMNMVtab2[16].val = 27; TMNMVtab2[16].len = 11;
    TMNMVtab2[17].val = 37; TMNMVtab2[17].len = 11;
    TMNMVtab2[18].val = 37; TMNMVtab2[18].len = 11;
    TMNMVtab2[19].val = 26; TMNMVtab2[19].len = 11;
    TMNMVtab2[20].val = 26; TMNMVtab2[20].len = 11;
    TMNMVtab2[21].val = 38; TMNMVtab2[21].len = 11;
    TMNMVtab2[22].val = 38; TMNMVtab2[22].len = 11;
    TMNMVtab2[23].val = 25; TMNMVtab2[23].len = 11;
    TMNMVtab2[24].val = 25; TMNMVtab2[24].len = 11;
    TMNMVtab2[25].val = 39; TMNMVtab2[25].len = 11;
    TMNMVtab2[26].val = 39; TMNMVtab2[26].len = 11;
    TMNMVtab2[27].val = 24; TMNMVtab2[27].len = 10;
    TMNMVtab2[28].val = 24; TMNMVtab2[28].len = 10;
    TMNMVtab2[29].val = 24; TMNMVtab2[29].len = 10;
    TMNMVtab2[30].val = 24; TMNMVtab2[30].len = 10;
    TMNMVtab2[31].val = 40; TMNMVtab2[31].len = 10;
    TMNMVtab2[32].val = 40; TMNMVtab2[32].len = 10;
    TMNMVtab2[33].val = 40; TMNMVtab2[33].len = 10;
    TMNMVtab2[34].val = 40; TMNMVtab2[34].len = 10;
    TMNMVtab2[35].val = 23; TMNMVtab2[35].len = 10;
    TMNMVtab2[36].val = 23; TMNMVtab2[36].len = 10;
    TMNMVtab2[37].val = 23; TMNMVtab2[37].len = 10;
    TMNMVtab2[38].val = 23; TMNMVtab2[38].len = 10;
    TMNMVtab2[39].val = 41; TMNMVtab2[39].len = 10;
    TMNMVtab2[40].val = 41; TMNMVtab2[40].len = 10;
    TMNMVtab2[41].val = 41; TMNMVtab2[41].len = 10;
    TMNMVtab2[42].val = 41; TMNMVtab2[42].len = 10;
    TMNMVtab2[43].val = 22; TMNMVtab2[43].len = 10;
    TMNMVtab2[44].val = 22; TMNMVtab2[44].len = 10;
    TMNMVtab2[45].val = 22; TMNMVtab2[45].len = 10;
    TMNMVtab2[46].val = 22; TMNMVtab2[46].len = 10;
    TMNMVtab2[47].val = 42; TMNMVtab2[47].len = 10;
    TMNMVtab2[48].val = 42; TMNMVtab2[48].len = 10;
    TMNMVtab2[49].val = 42; TMNMVtab2[49].len = 10;
    TMNMVtab2[50].val = 42; TMNMVtab2[50].len = 10;
    TMNMVtab2[51].val = 21; TMNMVtab2[51].len = 10;
    TMNMVtab2[52].val = 21; TMNMVtab2[52].len = 10;
    TMNMVtab2[53].val = 21; TMNMVtab2[53].len = 10;
    TMNMVtab2[54].val = 21; TMNMVtab2[54].len = 10;
    TMNMVtab2[55].val = 43; TMNMVtab2[55].len = 10;
    TMNMVtab2[56].val = 43; TMNMVtab2[56].len = 10;
    TMNMVtab2[57].val = 43; TMNMVtab2[57].len = 10;
    TMNMVtab2[58].val = 43; TMNMVtab2[58].len = 10;
    TMNMVtab2[59].val = 20; TMNMVtab2[59].len = 10;
    TMNMVtab2[60].val = 20; TMNMVtab2[60].len = 10;
    TMNMVtab2[61].val = 20; TMNMVtab2[61].len = 10;
    TMNMVtab2[62].val = 20; TMNMVtab2[62].len = 10;
    TMNMVtab2[63].val = 44; TMNMVtab2[63].len = 10;
    TMNMVtab2[64].val = 44; TMNMVtab2[64].len = 10;
    TMNMVtab2[65].val = 44; TMNMVtab2[65].len = 10;
    TMNMVtab2[66].val = 44; TMNMVtab2[66].len = 10;
    TMNMVtab2[67].val = 19; TMNMVtab2[67].len = 10;
    TMNMVtab2[68].val = 19; TMNMVtab2[68].len = 10;
    TMNMVtab2[69].val = 19; TMNMVtab2[69].len = 10;
    TMNMVtab2[70].val = 19; TMNMVtab2[70].len = 10;
    TMNMVtab2[71].val = 45; TMNMVtab2[71].len = 10;
    TMNMVtab2[72].val = 45; TMNMVtab2[72].len = 10;
    TMNMVtab2[73].val = 45; TMNMVtab2[73].len = 10;
    TMNMVtab2[74].val = 45; TMNMVtab2[74].len = 10;
    TMNMVtab2[75].val = 18; TMNMVtab2[75].len = 10;
    TMNMVtab2[76].val = 18; TMNMVtab2[76].len = 10;
    TMNMVtab2[77].val = 18; TMNMVtab2[77].len = 10;
    TMNMVtab2[78].val = 18; TMNMVtab2[78].len = 10;
    TMNMVtab2[79].val = 46; TMNMVtab2[79].len = 10;
    TMNMVtab2[80].val = 46; TMNMVtab2[80].len = 10;
    TMNMVtab2[81].val = 46; TMNMVtab2[81].len = 10;
    TMNMVtab2[82].val = 46; TMNMVtab2[82].len = 10;
    TMNMVtab2[83].val = 17; TMNMVtab2[83].len = 10;
    TMNMVtab2[84].val = 17; TMNMVtab2[84].len = 10;
    TMNMVtab2[85].val = 17; TMNMVtab2[85].len = 10;
    TMNMVtab2[86].val = 17; TMNMVtab2[86].len = 10;
    TMNMVtab2[87].val = 47; TMNMVtab2[87].len = 10;
    TMNMVtab2[88].val = 47; TMNMVtab2[88].len = 10;
    TMNMVtab2[89].val = 47; TMNMVtab2[89].len = 10;
    TMNMVtab2[90].val = 47; TMNMVtab2[90].len = 10;
    TMNMVtab2[91].val = 16; TMNMVtab2[91].len = 10;
    TMNMVtab2[92].val = 16; TMNMVtab2[92].len = 10;
    TMNMVtab2[93].val = 16; TMNMVtab2[93].len = 10;
    TMNMVtab2[94].val = 16; TMNMVtab2[94].len = 10;
    TMNMVtab2[95].val = 48; TMNMVtab2[95].len = 10;
    TMNMVtab2[96].val = 48; TMNMVtab2[96].len = 10;
    TMNMVtab2[97].val = 48; TMNMVtab2[97].len = 10;
    TMNMVtab2[98].val = 48; TMNMVtab2[98].len = 10;
    TMNMVtab2[99].val = 15; TMNMVtab2[99].len = 10;
    TMNMVtab2[100].val = 15; TMNMVtab2[100].len = 10;
    TMNMVtab2[101].val = 15; TMNMVtab2[101].len = 10;
    TMNMVtab2[102].val = 15; TMNMVtab2[102].len = 10;
    TMNMVtab2[103].val = 49; TMNMVtab2[103].len = 10;
    TMNMVtab2[104].val = 49; TMNMVtab2[104].len = 10;
    TMNMVtab2[105].val = 49; TMNMVtab2[105].len = 10;
    TMNMVtab2[106].val = 49; TMNMVtab2[106].len = 10;
    TMNMVtab2[107].val = 14; TMNMVtab2[107].len = 10;
    TMNMVtab2[108].val = 14; TMNMVtab2[108].len = 10;
    TMNMVtab2[109].val = 14; TMNMVtab2[109].len = 10;
    TMNMVtab2[110].val = 14; TMNMVtab2[110].len = 10;
    TMNMVtab2[111].val = 50; TMNMVtab2[111].len = 10;
    TMNMVtab2[112].val = 50; TMNMVtab2[112].len = 10;
    TMNMVtab2[113].val = 50; TMNMVtab2[113].len = 10;
    TMNMVtab2[114].val = 50; TMNMVtab2[114].len = 10;
    TMNMVtab2[115].val = 13; TMNMVtab2[115].len = 10;
    TMNMVtab2[116].val = 13; TMNMVtab2[116].len = 10;
    TMNMVtab2[117].val = 13; TMNMVtab2[117].len = 10;
    TMNMVtab2[118].val = 13; TMNMVtab2[118].len = 10;
    TMNMVtab2[119].val = 51; TMNMVtab2[119].len = 10;
    TMNMVtab2[120].val = 51; TMNMVtab2[120].len = 10;
    TMNMVtab2[121].val = 51; TMNMVtab2[121].len = 10;
    TMNMVtab2[122].val = 51; TMNMVtab2[122].len = 10;
  }

  
  static void initMCBPCt(){
    
    int x;

    MCBPCtab = new vlctabh[256];

    for (int i = 0; i < 256; i++)
      MCBPCtab[i] = new vlctabh();

    MCBPCtab[0].val = -1; MCBPCtab[0].len = 0;
    MCBPCtab[1].val = 255; MCBPCtab[1].len = 9;
    MCBPCtab[2].val = 52; MCBPCtab[2].len = 9;
    MCBPCtab[3].val = 36; MCBPCtab[3].len = 9;
    MCBPCtab[4].val = 20; MCBPCtab[4].len = 9;
    MCBPCtab[5].val = 49; MCBPCtab[5].len = 9;
    MCBPCtab[6].val = 35; MCBPCtab[6].len = 8;
    MCBPCtab[7].val = 35; MCBPCtab[7].len = 8;
    MCBPCtab[8].val = 19; MCBPCtab[8].len = 8;
    MCBPCtab[9].val = 19; MCBPCtab[9].len = 8;
    MCBPCtab[10].val = 50; MCBPCtab[10].len = 8;
    MCBPCtab[11].val = 50; MCBPCtab[11].len = 8;
    MCBPCtab[12].val = 51; MCBPCtab[12].len = 7;
    MCBPCtab[13].val = 51; MCBPCtab[13].len = 7;
    MCBPCtab[14].val = 51; MCBPCtab[14].len = 7;
    MCBPCtab[15].val = 51; MCBPCtab[15].len = 7;
    MCBPCtab[16].val = 34; MCBPCtab[16].len = 7;
    MCBPCtab[17].val = 34; MCBPCtab[17].len = 7;
    MCBPCtab[18].val = 34; MCBPCtab[18].len = 7;
    MCBPCtab[19].val = 34; MCBPCtab[19].len = 7;
    MCBPCtab[20].val = 18; MCBPCtab[20].len = 7;
    MCBPCtab[21].val = 18; MCBPCtab[21].len = 7;
    MCBPCtab[22].val = 18; MCBPCtab[22].len = 7;
    MCBPCtab[23].val = 18; MCBPCtab[23].len = 7;
    MCBPCtab[24].val = 33; MCBPCtab[24].len = 7;
    MCBPCtab[25].val = 33; MCBPCtab[25].len = 7;
    MCBPCtab[26].val = 33; MCBPCtab[26].len = 7;
    MCBPCtab[27].val = 33; MCBPCtab[27].len = 7;
    MCBPCtab[28].val = 17; MCBPCtab[28].len = 7;
    MCBPCtab[29].val = 17; MCBPCtab[29].len = 7;
    MCBPCtab[30].val = 17; MCBPCtab[30].len = 7;
    MCBPCtab[31].val = 17; MCBPCtab[31].len = 7;
    MCBPCtab[32].val = 4; MCBPCtab[32].len = 6;
    MCBPCtab[33].val = 4; MCBPCtab[33].len = 6;
    MCBPCtab[34].val = 4; MCBPCtab[34].len = 6;
    MCBPCtab[35].val = 4; MCBPCtab[35].len = 6;
    MCBPCtab[36].val = 4; MCBPCtab[36].len = 6;
    MCBPCtab[37].val = 4; MCBPCtab[37].len = 6;
    MCBPCtab[38].val = 4; MCBPCtab[38].len = 6;
    MCBPCtab[39].val = 4; MCBPCtab[39].len = 6;
    MCBPCtab[40].val = 48; MCBPCtab[40].len = 6;
    MCBPCtab[41].val = 48; MCBPCtab[41].len = 6;
    MCBPCtab[42].val = 48; MCBPCtab[42].len = 6;
    MCBPCtab[43].val = 48; MCBPCtab[43].len = 6;
    MCBPCtab[44].val = 48; MCBPCtab[44].len = 6;
    MCBPCtab[45].val = 48; MCBPCtab[45].len = 6;
    MCBPCtab[46].val = 48; MCBPCtab[46].len = 6;
    MCBPCtab[47].val = 48; MCBPCtab[47].len = 6;
    MCBPCtab[48].val = 3; MCBPCtab[48].len = 5;
    MCBPCtab[49].val = 3; MCBPCtab[49].len = 5;
    MCBPCtab[50].val = 3; MCBPCtab[50].len = 5;
    MCBPCtab[51].val = 3; MCBPCtab[51].len = 5;
    MCBPCtab[52].val = 3; MCBPCtab[52].len = 5;
    MCBPCtab[53].val = 3; MCBPCtab[53].len = 5;
    MCBPCtab[54].val = 3; MCBPCtab[54].len = 5;
    MCBPCtab[55].val = 3; MCBPCtab[55].len = 5;
    MCBPCtab[56].val = 3; MCBPCtab[56].len = 5;
    MCBPCtab[57].val = 3; MCBPCtab[57].len = 5;
    MCBPCtab[58].val = 3; MCBPCtab[58].len = 5;
    MCBPCtab[59].val = 3; MCBPCtab[59].len = 5;
    MCBPCtab[60].val = 3; MCBPCtab[60].len = 5;
    MCBPCtab[61].val = 3; MCBPCtab[61].len = 5;
    MCBPCtab[62].val = 3; MCBPCtab[62].len = 5;
    MCBPCtab[63].val = 3; MCBPCtab[63].len = 5;
    MCBPCtab[64].val = 32; MCBPCtab[64].len = 4;
    MCBPCtab[65].val = 32; MCBPCtab[65].len = 4;
    MCBPCtab[66].val = 32; MCBPCtab[66].len = 4;
    MCBPCtab[67].val = 32; MCBPCtab[67].len = 4;
    MCBPCtab[68].val = 32; MCBPCtab[68].len = 4;
    MCBPCtab[69].val = 32; MCBPCtab[69].len = 4;
    MCBPCtab[70].val = 32; MCBPCtab[70].len = 4;
    MCBPCtab[71].val = 32; MCBPCtab[71].len = 4;
    MCBPCtab[72].val = 32; MCBPCtab[72].len = 4;
    MCBPCtab[73].val = 32; MCBPCtab[73].len = 4;
    MCBPCtab[74].val = 32; MCBPCtab[74].len = 4;
    MCBPCtab[75].val = 32; MCBPCtab[75].len = 4;
    MCBPCtab[76].val = 32; MCBPCtab[76].len = 4;
    MCBPCtab[77].val = 32; MCBPCtab[77].len = 4;
    MCBPCtab[78].val = 32; MCBPCtab[78].len = 4;
    MCBPCtab[79].val = 32; MCBPCtab[79].len = 4;
    MCBPCtab[80].val = 32; MCBPCtab[80].len = 4;
    MCBPCtab[81].val = 32; MCBPCtab[81].len = 4;
    MCBPCtab[82].val = 32; MCBPCtab[82].len = 4;
    MCBPCtab[83].val = 32; MCBPCtab[83].len = 4;
    MCBPCtab[84].val = 32; MCBPCtab[84].len = 4;
    MCBPCtab[85].val = 32; MCBPCtab[85].len = 4;
    MCBPCtab[86].val = 32; MCBPCtab[86].len = 4;
    MCBPCtab[87].val = 32; MCBPCtab[87].len = 4;
    MCBPCtab[88].val = 32; MCBPCtab[88].len = 4;
    MCBPCtab[89].val = 32; MCBPCtab[89].len = 4;
    MCBPCtab[90].val = 32; MCBPCtab[90].len = 4;
    MCBPCtab[91].val = 32; MCBPCtab[91].len = 4;
    MCBPCtab[92].val = 32; MCBPCtab[92].len = 4;
    MCBPCtab[93].val = 32; MCBPCtab[93].len = 4;
    MCBPCtab[94].val = 32; MCBPCtab[94].len = 4;
    MCBPCtab[95].val = 32; MCBPCtab[95].len = 4;
    MCBPCtab[96].val = 16; MCBPCtab[96].len = 4;
    MCBPCtab[97].val = 16; MCBPCtab[97].len = 4;
    MCBPCtab[98].val = 16; MCBPCtab[98].len = 4;
    MCBPCtab[99].val = 16; MCBPCtab[99].len = 4;
    MCBPCtab[100].val = 16; MCBPCtab[100].len = 4;
    MCBPCtab[101].val = 16; MCBPCtab[101].len = 4;
    MCBPCtab[102].val = 16; MCBPCtab[102].len = 4;
    MCBPCtab[103].val = 16; MCBPCtab[103].len = 4;
    MCBPCtab[104].val = 16; MCBPCtab[104].len = 4;
    MCBPCtab[105].val = 16; MCBPCtab[105].len = 4;
    MCBPCtab[106].val = 16; MCBPCtab[106].len = 4;
    MCBPCtab[107].val = 16; MCBPCtab[107].len = 4;
    MCBPCtab[108].val = 16; MCBPCtab[108].len = 4;
    MCBPCtab[109].val = 16; MCBPCtab[109].len = 4;
    MCBPCtab[110].val = 16; MCBPCtab[110].len = 4;
    MCBPCtab[111].val = 16; MCBPCtab[111].len = 4;
    MCBPCtab[112].val = 16; MCBPCtab[112].len = 4;
    MCBPCtab[113].val = 16; MCBPCtab[113].len = 4;
    MCBPCtab[114].val = 16; MCBPCtab[114].len = 4;
    MCBPCtab[115].val = 16; MCBPCtab[115].len = 4;
    MCBPCtab[116].val = 16; MCBPCtab[116].len = 4;
    MCBPCtab[117].val = 16; MCBPCtab[117].len = 4;
    MCBPCtab[118].val = 16; MCBPCtab[118].len = 4;
    MCBPCtab[119].val = 16; MCBPCtab[119].len = 4;
    MCBPCtab[120].val = 16; MCBPCtab[120].len = 4;
    MCBPCtab[121].val = 16; MCBPCtab[121].len = 4;
    MCBPCtab[122].val = 16; MCBPCtab[122].len = 4;
    MCBPCtab[123].val = 16; MCBPCtab[123].len = 4;
    MCBPCtab[124].val = 16; MCBPCtab[124].len = 4;
    MCBPCtab[125].val = 16; MCBPCtab[125].len = 4;
    MCBPCtab[126].val = 16; MCBPCtab[126].len = 4;
    MCBPCtab[127].val = 16; MCBPCtab[127].len = 4;
    MCBPCtab[128].val = 2; MCBPCtab[128].len = 3;
    MCBPCtab[129].val = 2; MCBPCtab[129].len = 3;
    MCBPCtab[130].val = 2; MCBPCtab[130].len = 3;
    MCBPCtab[131].val = 2; MCBPCtab[131].len = 3;
    MCBPCtab[132].val = 2; MCBPCtab[132].len = 3;
    MCBPCtab[133].val = 2; MCBPCtab[133].len = 3;
    MCBPCtab[134].val = 2; MCBPCtab[134].len = 3;
    MCBPCtab[135].val = 2; MCBPCtab[135].len = 3;
    MCBPCtab[136].val = 2; MCBPCtab[136].len = 3;
    MCBPCtab[137].val = 2; MCBPCtab[137].len = 3;
    MCBPCtab[138].val = 2; MCBPCtab[138].len = 3;
    MCBPCtab[139].val = 2; MCBPCtab[139].len = 3;
    MCBPCtab[140].val = 2; MCBPCtab[140].len = 3;
    MCBPCtab[141].val = 2; MCBPCtab[141].len = 3;
    MCBPCtab[142].val = 2; MCBPCtab[142].len = 3;
    MCBPCtab[143].val = 2; MCBPCtab[143].len = 3;
    MCBPCtab[144].val = 2; MCBPCtab[144].len = 3;
    MCBPCtab[145].val = 2; MCBPCtab[145].len = 3;
    MCBPCtab[146].val = 2; MCBPCtab[146].len = 3;
    MCBPCtab[147].val = 2; MCBPCtab[147].len = 3;
    MCBPCtab[148].val = 2; MCBPCtab[148].len = 3;
    MCBPCtab[149].val = 2; MCBPCtab[149].len = 3;
    MCBPCtab[150].val = 2; MCBPCtab[150].len = 3;
    MCBPCtab[151].val = 2; MCBPCtab[151].len = 3;
    MCBPCtab[152].val = 2; MCBPCtab[152].len = 3;
    MCBPCtab[153].val = 2; MCBPCtab[153].len = 3;
    MCBPCtab[154].val = 2; MCBPCtab[154].len = 3;
    MCBPCtab[155].val = 2; MCBPCtab[155].len = 3;
    MCBPCtab[156].val = 2; MCBPCtab[156].len = 3;
    MCBPCtab[157].val = 2; MCBPCtab[157].len = 3;
    MCBPCtab[158].val = 2; MCBPCtab[158].len = 3;
    MCBPCtab[159].val = 2; MCBPCtab[159].len = 3;
    MCBPCtab[160].val = 2; MCBPCtab[160].len = 3;
    MCBPCtab[161].val = 2; MCBPCtab[161].len = 3;
    MCBPCtab[162].val = 2; MCBPCtab[162].len = 3;
    MCBPCtab[163].val = 2; MCBPCtab[163].len = 3;
    MCBPCtab[164].val = 2; MCBPCtab[164].len = 3;
    MCBPCtab[165].val = 2; MCBPCtab[165].len = 3;
    MCBPCtab[166].val = 2; MCBPCtab[166].len = 3;
    MCBPCtab[167].val = 2; MCBPCtab[167].len = 3;
    MCBPCtab[168].val = 2; MCBPCtab[168].len = 3;
    MCBPCtab[169].val = 2; MCBPCtab[169].len = 3;
    MCBPCtab[170].val = 2; MCBPCtab[170].len = 3;
    MCBPCtab[171].val = 2; MCBPCtab[171].len = 3;
    MCBPCtab[172].val = 2; MCBPCtab[172].len = 3;
    MCBPCtab[173].val = 2; MCBPCtab[173].len = 3;
    MCBPCtab[174].val = 2; MCBPCtab[174].len = 3;
    MCBPCtab[175].val = 2; MCBPCtab[175].len = 3;
    MCBPCtab[176].val = 2; MCBPCtab[176].len = 3;
    MCBPCtab[177].val = 2; MCBPCtab[177].len = 3;
    MCBPCtab[178].val = 2; MCBPCtab[178].len = 3;
    MCBPCtab[179].val = 2; MCBPCtab[179].len = 3;
    MCBPCtab[180].val = 2; MCBPCtab[180].len = 3;
    MCBPCtab[181].val = 2; MCBPCtab[181].len = 3;
    MCBPCtab[182].val = 2; MCBPCtab[182].len = 3;
    MCBPCtab[183].val = 2; MCBPCtab[183].len = 3;
    MCBPCtab[184].val = 2; MCBPCtab[184].len = 3;
    MCBPCtab[185].val = 2; MCBPCtab[185].len = 3;
    MCBPCtab[186].val = 2; MCBPCtab[186].len = 3;
    MCBPCtab[187].val = 2; MCBPCtab[187].len = 3;
    MCBPCtab[188].val = 2; MCBPCtab[188].len = 3;
    MCBPCtab[189].val = 2; MCBPCtab[189].len = 3;
    MCBPCtab[190].val = 2; MCBPCtab[190].len = 3;
    MCBPCtab[191].val = 2; MCBPCtab[191].len = 3;
    MCBPCtab[192].val = 1; MCBPCtab[192].len = 3;
    MCBPCtab[193].val = 1; MCBPCtab[193].len = 3;
    MCBPCtab[194].val = 1; MCBPCtab[194].len = 3;
    MCBPCtab[195].val = 1; MCBPCtab[195].len = 3;
    MCBPCtab[196].val = 1; MCBPCtab[196].len = 3;
    MCBPCtab[197].val = 1; MCBPCtab[197].len = 3;
    MCBPCtab[198].val = 1; MCBPCtab[198].len = 3;
    MCBPCtab[199].val = 1; MCBPCtab[199].len = 3;
    MCBPCtab[200].val = 1; MCBPCtab[200].len = 3;
    MCBPCtab[201].val = 1; MCBPCtab[201].len = 3;
    MCBPCtab[202].val = 1; MCBPCtab[202].len = 3;
    MCBPCtab[203].val = 1; MCBPCtab[203].len = 3;
    MCBPCtab[204].val = 1; MCBPCtab[204].len = 3;
    MCBPCtab[205].val = 1; MCBPCtab[205].len = 3;
    MCBPCtab[206].val = 1; MCBPCtab[206].len = 3;
    MCBPCtab[207].val = 1; MCBPCtab[207].len = 3;
    MCBPCtab[208].val = 1; MCBPCtab[208].len = 3;
    MCBPCtab[209].val = 1; MCBPCtab[209].len = 3;
    MCBPCtab[210].val = 1; MCBPCtab[210].len = 3;
    MCBPCtab[211].val = 1; MCBPCtab[211].len = 3;
    MCBPCtab[212].val = 1; MCBPCtab[212].len = 3;
    MCBPCtab[213].val = 1; MCBPCtab[213].len = 3;
    MCBPCtab[214].val = 1; MCBPCtab[214].len = 3;
    MCBPCtab[215].val = 1; MCBPCtab[215].len = 3;
    MCBPCtab[216].val = 1; MCBPCtab[216].len = 3;
    MCBPCtab[217].val = 1; MCBPCtab[217].len = 3;
    MCBPCtab[218].val = 1; MCBPCtab[218].len = 3;
    MCBPCtab[219].val = 1; MCBPCtab[219].len = 3;
    MCBPCtab[220].val = 1; MCBPCtab[220].len = 3;
    MCBPCtab[221].val = 1; MCBPCtab[221].len = 3;
    MCBPCtab[222].val = 1; MCBPCtab[222].len = 3;
    MCBPCtab[223].val = 1; MCBPCtab[223].len = 3;
    MCBPCtab[224].val = 1; MCBPCtab[224].len = 3;
    MCBPCtab[225].val = 1; MCBPCtab[225].len = 3;
    MCBPCtab[226].val = 1; MCBPCtab[226].len = 3;
    MCBPCtab[227].val = 1; MCBPCtab[227].len = 3;
    MCBPCtab[228].val = 1; MCBPCtab[228].len = 3;
    MCBPCtab[229].val = 1; MCBPCtab[229].len = 3;
    MCBPCtab[230].val = 1; MCBPCtab[230].len = 3;
    MCBPCtab[231].val = 1; MCBPCtab[231].len = 3;
    MCBPCtab[232].val = 1; MCBPCtab[232].len = 3;
    MCBPCtab[233].val = 1; MCBPCtab[233].len = 3;
    MCBPCtab[234].val = 1; MCBPCtab[234].len = 3;
    MCBPCtab[235].val = 1; MCBPCtab[235].len = 3;
    MCBPCtab[236].val = 1; MCBPCtab[236].len = 3;
    MCBPCtab[237].val = 1; MCBPCtab[237].len = 3;
    MCBPCtab[238].val = 1; MCBPCtab[238].len = 3;
    MCBPCtab[239].val = 1; MCBPCtab[239].len = 3;
    MCBPCtab[240].val = 1; MCBPCtab[240].len = 3;
    MCBPCtab[241].val = 1; MCBPCtab[241].len = 3;
    MCBPCtab[242].val = 1; MCBPCtab[242].len = 3;
    MCBPCtab[243].val = 1; MCBPCtab[243].len = 3;
    MCBPCtab[244].val = 1; MCBPCtab[244].len = 3;
    MCBPCtab[245].val = 1; MCBPCtab[245].len = 3;
    MCBPCtab[246].val = 1; MCBPCtab[246].len = 3;
    MCBPCtab[247].val = 1; MCBPCtab[247].len = 3;
    MCBPCtab[248].val = 1; MCBPCtab[248].len = 3;
    MCBPCtab[249].val = 1; MCBPCtab[249].len = 3;
    MCBPCtab[250].val = 1; MCBPCtab[250].len = 3;
    MCBPCtab[251].val = 1; MCBPCtab[251].len = 3;
    MCBPCtab[252].val = 1; MCBPCtab[252].len = 3;
    MCBPCtab[253].val = 1; MCBPCtab[253].len = 3;
    MCBPCtab[254].val = 1; MCBPCtab[254].len = 3;
    MCBPCtab[255].val = 1; MCBPCtab[255].len = 3;
  }

  static void initMCBPCtintra(){
    
    int x;

    MCBPCtabintra = new vlctabh[32];

    for (int i = 0; i < 32; i++)
      MCBPCtabintra[i] = new vlctabh();
    
    MCBPCtabintra[0].val = -1; MCBPCtabintra[0].len = 0;
    MCBPCtabintra[1].val = 20; MCBPCtabintra[1].len = 6;
    MCBPCtabintra[2].val = 36; MCBPCtabintra[2].len = 6;
    MCBPCtabintra[3].val = 52; MCBPCtabintra[3].len = 6;
    MCBPCtabintra[4].val = 4; MCBPCtabintra[4].len = 4;
    MCBPCtabintra[5].val = 4; MCBPCtabintra[5].len = 4;
    MCBPCtabintra[6].val = 4; MCBPCtabintra[6].len = 4;
    MCBPCtabintra[7].val = 4; MCBPCtabintra[7].len = 4;
    MCBPCtabintra[8].val = 19; MCBPCtabintra[8].len = 3;
    MCBPCtabintra[9].val = 19; MCBPCtabintra[9].len = 3;
    MCBPCtabintra[10].val = 19; MCBPCtabintra[10].len = 3;
    MCBPCtabintra[11].val = 19; MCBPCtabintra[11].len = 3;
    MCBPCtabintra[12].val = 19; MCBPCtabintra[12].len = 3;
    MCBPCtabintra[13].val = 19; MCBPCtabintra[13].len = 3;
    MCBPCtabintra[14].val = 19; MCBPCtabintra[14].len = 3;
    MCBPCtabintra[15].val = 19; MCBPCtabintra[15].len = 3;
    MCBPCtabintra[16].val = 35; MCBPCtabintra[16].len = 3;
    MCBPCtabintra[17].val = 35; MCBPCtabintra[17].len = 3;
    MCBPCtabintra[18].val = 35; MCBPCtabintra[18].len = 3;
    MCBPCtabintra[19].val = 35; MCBPCtabintra[19].len = 3;
    MCBPCtabintra[20].val = 35; MCBPCtabintra[20].len = 3;
    MCBPCtabintra[21].val = 35; MCBPCtabintra[21].len = 3;
    MCBPCtabintra[22].val = 35; MCBPCtabintra[22].len = 3;
    MCBPCtabintra[23].val = 35; MCBPCtabintra[23].len = 3;
    MCBPCtabintra[24].val = 51; MCBPCtabintra[24].len = 3;
    MCBPCtabintra[25].val = 51; MCBPCtabintra[25].len = 3;
    MCBPCtabintra[26].val = 51; MCBPCtabintra[26].len = 3;
    MCBPCtabintra[27].val = 51; MCBPCtabintra[27].len = 3;
    MCBPCtabintra[28].val = 51; MCBPCtabintra[28].len = 3;
    MCBPCtabintra[29].val = 51; MCBPCtabintra[29].len = 3;
    MCBPCtabintra[30].val = 51; MCBPCtabintra[30].len = 3;
    MCBPCtabintra[31].val = 51; MCBPCtabintra[31].len = 3;
    
  }

  static void initCBPY(){

    int x;

    CBPYtab = new vlctabh[48];

    for (int i = 0; i < 48; i++)
      CBPYtab[i] = new vlctabh();

    CBPYtab[0].val = -1; CBPYtab[0].len = 0;
    CBPYtab[1].val = -1; CBPYtab[1].len = 0;
    CBPYtab[2].val = 9; CBPYtab[2].len = 6;
    CBPYtab[3].val = 6; CBPYtab[3].len = 6;
    CBPYtab[4].val = 7; CBPYtab[4].len = 5;
    CBPYtab[5].val = 7; CBPYtab[5].len = 5;
    CBPYtab[6].val = 11; CBPYtab[6].len = 5;
    CBPYtab[7].val = 11; CBPYtab[7].len = 5;
    CBPYtab[8].val = 13; CBPYtab[8].len = 5;
    CBPYtab[9].val = 13; CBPYtab[9].len = 5;
    CBPYtab[10].val = 14; CBPYtab[10].len = 5;
    CBPYtab[11].val = 14; CBPYtab[11].len = 5;
    CBPYtab[12].val = 15; CBPYtab[12].len = 4;
    CBPYtab[13].val = 15; CBPYtab[13].len = 4;
    CBPYtab[14].val = 15; CBPYtab[14].len = 4;
    CBPYtab[15].val = 15; CBPYtab[15].len = 4;
    CBPYtab[16].val = 3; CBPYtab[16].len = 4;
    CBPYtab[17].val = 3; CBPYtab[17].len = 4;
    CBPYtab[18].val = 3; CBPYtab[18].len = 4;
    CBPYtab[19].val = 3; CBPYtab[19].len = 4;
    CBPYtab[20].val = 5; CBPYtab[20].len = 4;
    CBPYtab[21].val = 5; CBPYtab[21].len = 4;
    CBPYtab[22].val = 5; CBPYtab[22].len = 4;
    CBPYtab[23].val = 5; CBPYtab[23].len = 4;
    CBPYtab[24].val = 1; CBPYtab[24].len = 4;
    CBPYtab[25].val = 1; CBPYtab[25].len = 4;
    CBPYtab[26].val = 1; CBPYtab[26].len = 4;
    CBPYtab[27].val = 1; CBPYtab[27].len = 4;
    CBPYtab[28].val = 10; CBPYtab[28].len = 4;
    CBPYtab[29].val = 10; CBPYtab[29].len = 4;
    CBPYtab[30].val = 10; CBPYtab[30].len = 4;
    CBPYtab[31].val = 10; CBPYtab[31].len = 4;
    CBPYtab[32].val = 2; CBPYtab[32].len = 4;
    CBPYtab[33].val = 2; CBPYtab[33].len = 4;
    CBPYtab[34].val = 2; CBPYtab[34].len = 4;
    CBPYtab[35].val = 2; CBPYtab[35].len = 4;
    CBPYtab[36].val = 12; CBPYtab[36].len = 4;
    CBPYtab[37].val = 12; CBPYtab[37].len = 4;
    CBPYtab[38].val = 12; CBPYtab[38].len = 4;
    CBPYtab[39].val = 12; CBPYtab[39].len = 4;
    CBPYtab[40].val = 4; CBPYtab[40].len = 4;
    CBPYtab[41].val = 4; CBPYtab[41].len = 4;
    CBPYtab[42].val = 4; CBPYtab[42].len = 4;
    CBPYtab[43].val = 4; CBPYtab[43].len = 4;
    CBPYtab[44].val = 8; CBPYtab[44].len = 4;
    CBPYtab[45].val = 8; CBPYtab[45].len = 4;
    CBPYtab[46].val = 8; CBPYtab[46].len = 4;
    CBPYtab[47].val = 8; CBPYtab[47].len = 4;
  }
  
  static void initDCT3D0(){
    
    int x;

    DCT3Dtab0 = new vlctabh[112];

    for (int i = 0; i < 112; i++)
      DCT3Dtab0[i] = new vlctabh();

    DCT3Dtab0[0].val = 4225; DCT3Dtab0[0].len = 7;
    DCT3Dtab0[1].val = 4209; DCT3Dtab0[1].len = 7;
    DCT3Dtab0[2].val = 4193; DCT3Dtab0[2].len = 7;
    DCT3Dtab0[3].val = 4177; DCT3Dtab0[3].len = 7;
    DCT3Dtab0[4].val = 193; DCT3Dtab0[4].len = 7;
    DCT3Dtab0[5].val = 177; DCT3Dtab0[5].len = 7;
    DCT3Dtab0[6].val = 161; DCT3Dtab0[6].len = 7;
    DCT3Dtab0[7].val = 4; DCT3Dtab0[7].len = 7;
    DCT3Dtab0[8].val = 4161; DCT3Dtab0[8].len = 6;
    DCT3Dtab0[9].val = 4161; DCT3Dtab0[9].len = 6;
    DCT3Dtab0[10].val = 4145; DCT3Dtab0[10].len = 6;
    DCT3Dtab0[11].val = 4145; DCT3Dtab0[11].len = 6;
    DCT3Dtab0[12].val = 4129; DCT3Dtab0[12].len = 6;
    DCT3Dtab0[13].val = 4129; DCT3Dtab0[13].len = 6;
    DCT3Dtab0[14].val = 4113; DCT3Dtab0[14].len = 6;
    DCT3Dtab0[15].val = 4113; DCT3Dtab0[15].len = 6;
    DCT3Dtab0[16].val = 145; DCT3Dtab0[16].len = 6;
    DCT3Dtab0[17].val = 145; DCT3Dtab0[17].len = 6;
    DCT3Dtab0[18].val = 129; DCT3Dtab0[18].len = 6;
    DCT3Dtab0[19].val = 129; DCT3Dtab0[19].len = 6;
    DCT3Dtab0[20].val = 113; DCT3Dtab0[20].len = 6;
    DCT3Dtab0[21].val = 113; DCT3Dtab0[21].len = 6;
    DCT3Dtab0[22].val = 97; DCT3Dtab0[22].len = 6;
    DCT3Dtab0[23].val = 97; DCT3Dtab0[23].len = 6;
    DCT3Dtab0[24].val = 18; DCT3Dtab0[24].len = 6;
    DCT3Dtab0[25].val = 18; DCT3Dtab0[25].len = 6;
    DCT3Dtab0[26].val = 3; DCT3Dtab0[26].len = 6;
    DCT3Dtab0[27].val = 3; DCT3Dtab0[27].len = 6;
    DCT3Dtab0[28].val = 81; DCT3Dtab0[28].len = 5;
    DCT3Dtab0[29].val = 81; DCT3Dtab0[29].len = 5;
    DCT3Dtab0[30].val = 81; DCT3Dtab0[30].len = 5;
    DCT3Dtab0[31].val = 81; DCT3Dtab0[31].len = 5;
    DCT3Dtab0[32].val = 65; DCT3Dtab0[32].len = 5;
    DCT3Dtab0[33].val = 65; DCT3Dtab0[33].len = 5;
    DCT3Dtab0[34].val = 65; DCT3Dtab0[34].len = 5;
    DCT3Dtab0[35].val = 65; DCT3Dtab0[35].len = 5;
    DCT3Dtab0[36].val = 49; DCT3Dtab0[36].len = 5;
    DCT3Dtab0[37].val = 49; DCT3Dtab0[37].len = 5;
    DCT3Dtab0[38].val = 49; DCT3Dtab0[38].len = 5;
    DCT3Dtab0[39].val = 49; DCT3Dtab0[39].len = 5;
    DCT3Dtab0[40].val = 4097; DCT3Dtab0[40].len = 4;
    DCT3Dtab0[41].val = 4097; DCT3Dtab0[41].len = 4;
    DCT3Dtab0[42].val = 4097; DCT3Dtab0[42].len = 4;
    DCT3Dtab0[43].val = 4097; DCT3Dtab0[43].len = 4;
    DCT3Dtab0[44].val = 4097; DCT3Dtab0[44].len = 4;
    DCT3Dtab0[45].val = 4097; DCT3Dtab0[45].len = 4;
    DCT3Dtab0[46].val = 4097; DCT3Dtab0[46].len = 4;
    DCT3Dtab0[47].val = 4097; DCT3Dtab0[47].len = 4;
    DCT3Dtab0[48].val = 1; DCT3Dtab0[48].len = 2;
    DCT3Dtab0[49].val = 1; DCT3Dtab0[49].len = 2;
    DCT3Dtab0[50].val = 1; DCT3Dtab0[50].len = 2;
    DCT3Dtab0[51].val = 1; DCT3Dtab0[51].len = 2;
    DCT3Dtab0[52].val = 1; DCT3Dtab0[52].len = 2;
    DCT3Dtab0[53].val = 1; DCT3Dtab0[53].len = 2;
    DCT3Dtab0[54].val = 1; DCT3Dtab0[54].len = 2;
    DCT3Dtab0[55].val = 1; DCT3Dtab0[55].len = 2;
    DCT3Dtab0[56].val = 1; DCT3Dtab0[56].len = 2;
    DCT3Dtab0[57].val = 1; DCT3Dtab0[57].len = 2;
    DCT3Dtab0[58].val = 1; DCT3Dtab0[58].len = 2;
    DCT3Dtab0[59].val = 1; DCT3Dtab0[59].len = 2;
    DCT3Dtab0[60].val = 1; DCT3Dtab0[60].len = 2;
    DCT3Dtab0[61].val = 1; DCT3Dtab0[61].len = 2;
    DCT3Dtab0[62].val = 1; DCT3Dtab0[62].len = 2;
    DCT3Dtab0[63].val = 1; DCT3Dtab0[63].len = 2;
    DCT3Dtab0[64].val = 1; DCT3Dtab0[64].len = 2;
    DCT3Dtab0[65].val = 1; DCT3Dtab0[65].len = 2;
    DCT3Dtab0[66].val = 1; DCT3Dtab0[66].len = 2;
    DCT3Dtab0[67].val = 1; DCT3Dtab0[67].len = 2;
    DCT3Dtab0[68].val = 1; DCT3Dtab0[68].len = 2;
    DCT3Dtab0[69].val = 1; DCT3Dtab0[69].len = 2;
    DCT3Dtab0[70].val = 1; DCT3Dtab0[70].len = 2;
    DCT3Dtab0[71].val = 1; DCT3Dtab0[71].len = 2;
    DCT3Dtab0[72].val = 1; DCT3Dtab0[72].len = 2;
    DCT3Dtab0[73].val = 1; DCT3Dtab0[73].len = 2;
    DCT3Dtab0[74].val = 1; DCT3Dtab0[74].len = 2;
    DCT3Dtab0[75].val = 1; DCT3Dtab0[75].len = 2;
    DCT3Dtab0[76].val = 1; DCT3Dtab0[76].len = 2;
    DCT3Dtab0[77].val = 1; DCT3Dtab0[77].len = 2;
    DCT3Dtab0[78].val = 1; DCT3Dtab0[78].len = 2;
    DCT3Dtab0[79].val = 1; DCT3Dtab0[79].len = 2;
    DCT3Dtab0[80].val = 17; DCT3Dtab0[80].len = 3;
    DCT3Dtab0[81].val = 17; DCT3Dtab0[81].len = 3;
    DCT3Dtab0[82].val = 17; DCT3Dtab0[82].len = 3;
    DCT3Dtab0[83].val = 17; DCT3Dtab0[83].len = 3;
    DCT3Dtab0[84].val = 17; DCT3Dtab0[84].len = 3;
    DCT3Dtab0[85].val = 17; DCT3Dtab0[85].len = 3;
    DCT3Dtab0[86].val = 17; DCT3Dtab0[86].len = 3;
    DCT3Dtab0[87].val = 17; DCT3Dtab0[87].len = 3;
    DCT3Dtab0[88].val = 17; DCT3Dtab0[88].len = 3;
    DCT3Dtab0[89].val = 17; DCT3Dtab0[89].len = 3;
    DCT3Dtab0[90].val = 17; DCT3Dtab0[90].len = 3;
    DCT3Dtab0[91].val = 17; DCT3Dtab0[91].len = 3;
    DCT3Dtab0[92].val = 17; DCT3Dtab0[92].len = 3;
    DCT3Dtab0[93].val = 17; DCT3Dtab0[93].len = 3;
    DCT3Dtab0[94].val = 17; DCT3Dtab0[94].len = 3;
    DCT3Dtab0[95].val = 17; DCT3Dtab0[95].len = 3;
    DCT3Dtab0[96].val = 33; DCT3Dtab0[96].len = 4;
    DCT3Dtab0[97].val = 33; DCT3Dtab0[97].len = 4;
    DCT3Dtab0[98].val = 33; DCT3Dtab0[98].len = 4;
    DCT3Dtab0[99].val = 33; DCT3Dtab0[99].len = 4;
    DCT3Dtab0[100].val = 33; DCT3Dtab0[100].len = 4;
    DCT3Dtab0[101].val = 33; DCT3Dtab0[101].len = 4;
    DCT3Dtab0[102].val = 33; DCT3Dtab0[102].len = 4;
    DCT3Dtab0[103].val = 33; DCT3Dtab0[103].len = 4;
    DCT3Dtab0[104].val = 2; DCT3Dtab0[104].len = 4;
    DCT3Dtab0[105].val = 2; DCT3Dtab0[105].len = 4;
    DCT3Dtab0[106].val = 2; DCT3Dtab0[106].len = 4;
    DCT3Dtab0[107].val = 2; DCT3Dtab0[107].len = 4;
    DCT3Dtab0[108].val = 2; DCT3Dtab0[108].len = 4;
    DCT3Dtab0[109].val = 2; DCT3Dtab0[109].len = 4;
    DCT3Dtab0[110].val = 2; DCT3Dtab0[110].len = 4;
    DCT3Dtab0[111].val = 2; DCT3Dtab0[111].len = 4;
  }
  
  static void initDCT3D1(){

    int x;

    DCT3Dtab1 = new vlctabh[96];

    for (int i = 0; i < 96; i++)
      DCT3Dtab1[i] = new vlctabh();

    
    DCT3Dtab1[0].val = 9; DCT3Dtab1[0].len = 10;
    DCT3Dtab1[1].val = 8; DCT3Dtab1[1].len = 10;
    DCT3Dtab1[2].val = 4481; DCT3Dtab1[2].len = 9;
    DCT3Dtab1[3].val = 4481; DCT3Dtab1[3].len = 9;
    DCT3Dtab1[4].val = 4465; DCT3Dtab1[4].len = 9;
    DCT3Dtab1[5].val = 4465; DCT3Dtab1[5].len = 9;
    DCT3Dtab1[6].val = 4449; DCT3Dtab1[6].len = 9;
    DCT3Dtab1[7].val = 4449; DCT3Dtab1[7].len = 9;
    DCT3Dtab1[8].val = 4433; DCT3Dtab1[8].len = 9;
    DCT3Dtab1[9].val = 4433; DCT3Dtab1[9].len = 9;
    DCT3Dtab1[10].val = 4417; DCT3Dtab1[10].len = 9;
    DCT3Dtab1[11].val = 4417; DCT3Dtab1[11].len = 9;
    DCT3Dtab1[12].val = 4401; DCT3Dtab1[12].len = 9;
    DCT3Dtab1[13].val = 4401; DCT3Dtab1[13].len = 9;
    DCT3Dtab1[14].val = 4385; DCT3Dtab1[14].len = 9;
    DCT3Dtab1[15].val = 4385; DCT3Dtab1[15].len = 9;
    DCT3Dtab1[16].val = 4369; DCT3Dtab1[16].len = 9;
    DCT3Dtab1[17].val = 4369; DCT3Dtab1[17].len = 9;
    DCT3Dtab1[18].val = 4098; DCT3Dtab1[18].len = 9;
    DCT3Dtab1[19].val = 4098; DCT3Dtab1[19].len = 9;
    DCT3Dtab1[20].val = 353; DCT3Dtab1[20].len = 9;
    DCT3Dtab1[21].val = 353; DCT3Dtab1[21].len = 9;
    DCT3Dtab1[22].val = 337; DCT3Dtab1[22].len = 9;
    DCT3Dtab1[23].val = 337; DCT3Dtab1[23].len = 9;
    DCT3Dtab1[24].val = 321; DCT3Dtab1[24].len = 9;
    DCT3Dtab1[25].val = 321; DCT3Dtab1[25].len = 9;
    DCT3Dtab1[26].val = 305; DCT3Dtab1[26].len = 9;
    DCT3Dtab1[27].val = 305; DCT3Dtab1[27].len = 9;
    DCT3Dtab1[28].val = 289; DCT3Dtab1[28].len = 9;
    DCT3Dtab1[29].val = 289; DCT3Dtab1[29].len = 9;
    DCT3Dtab1[30].val = 273; DCT3Dtab1[30].len = 9;
    DCT3Dtab1[31].val = 273; DCT3Dtab1[31].len = 9;
    DCT3Dtab1[32].val = 257; DCT3Dtab1[32].len = 9;
    DCT3Dtab1[33].val = 257; DCT3Dtab1[33].len = 9;
    DCT3Dtab1[34].val = 241; DCT3Dtab1[34].len = 9;
    DCT3Dtab1[35].val = 241; DCT3Dtab1[35].len = 9;
    DCT3Dtab1[36].val = 66; DCT3Dtab1[36].len = 9;
    DCT3Dtab1[37].val = 66; DCT3Dtab1[37].len = 9;
    DCT3Dtab1[38].val = 50; DCT3Dtab1[38].len = 9;
    DCT3Dtab1[39].val = 50; DCT3Dtab1[39].len = 9;
    DCT3Dtab1[40].val = 7; DCT3Dtab1[40].len = 9;
    DCT3Dtab1[41].val = 7; DCT3Dtab1[41].len = 9;
    DCT3Dtab1[42].val = 6; DCT3Dtab1[42].len = 9;
    DCT3Dtab1[43].val = 6; DCT3Dtab1[43].len = 9;
    DCT3Dtab1[44].val = 4353; DCT3Dtab1[44].len = 8;
    DCT3Dtab1[45].val = 4353; DCT3Dtab1[45].len = 8;
    DCT3Dtab1[46].val = 4353; DCT3Dtab1[46].len = 8;
    DCT3Dtab1[47].val = 4353; DCT3Dtab1[47].len = 8;
    DCT3Dtab1[48].val = 4337; DCT3Dtab1[48].len = 8;
    DCT3Dtab1[49].val = 4337; DCT3Dtab1[49].len = 8;
    DCT3Dtab1[50].val = 4337; DCT3Dtab1[50].len = 8;
    DCT3Dtab1[51].val = 4337; DCT3Dtab1[51].len = 8;
    DCT3Dtab1[52].val = 4321; DCT3Dtab1[52].len = 8;
    DCT3Dtab1[53].val = 4321; DCT3Dtab1[53].len = 8;
    DCT3Dtab1[54].val = 4321; DCT3Dtab1[54].len = 8;
    DCT3Dtab1[55].val = 4321; DCT3Dtab1[55].len = 8;
    DCT3Dtab1[56].val = 4305; DCT3Dtab1[56].len = 8;
    DCT3Dtab1[57].val = 4305; DCT3Dtab1[57].len = 8;
    DCT3Dtab1[58].val = 4305; DCT3Dtab1[58].len = 8;
    DCT3Dtab1[59].val = 4305; DCT3Dtab1[59].len = 8;
    DCT3Dtab1[60].val = 4289; DCT3Dtab1[60].len = 8;
    DCT3Dtab1[61].val = 4289; DCT3Dtab1[61].len = 8;
    DCT3Dtab1[62].val = 4289; DCT3Dtab1[62].len = 8;
    DCT3Dtab1[63].val = 4289; DCT3Dtab1[63].len = 8;
    DCT3Dtab1[64].val = 4273; DCT3Dtab1[64].len = 8;
    DCT3Dtab1[65].val = 4273; DCT3Dtab1[65].len = 8;
    DCT3Dtab1[66].val = 4273; DCT3Dtab1[66].len = 8;
    DCT3Dtab1[67].val = 4273; DCT3Dtab1[67].len = 8;
    DCT3Dtab1[68].val = 4257; DCT3Dtab1[68].len = 8;
    DCT3Dtab1[69].val = 4257; DCT3Dtab1[69].len = 8;
    DCT3Dtab1[70].val = 4257; DCT3Dtab1[70].len = 8;
    DCT3Dtab1[71].val = 4257; DCT3Dtab1[71].len = 8;
    DCT3Dtab1[72].val = 4241; DCT3Dtab1[72].len = 8;
    DCT3Dtab1[73].val = 4241; DCT3Dtab1[73].len = 8;
    DCT3Dtab1[74].val = 4241; DCT3Dtab1[74].len = 8;
    DCT3Dtab1[75].val = 4241; DCT3Dtab1[75].len = 8;
    DCT3Dtab1[76].val = 225; DCT3Dtab1[76].len = 8;
    DCT3Dtab1[77].val = 225; DCT3Dtab1[77].len = 8;
    DCT3Dtab1[78].val = 225; DCT3Dtab1[78].len = 8;
    DCT3Dtab1[79].val = 225; DCT3Dtab1[79].len = 8;
    DCT3Dtab1[80].val = 209; DCT3Dtab1[80].len = 8;
    DCT3Dtab1[81].val = 209; DCT3Dtab1[81].len = 8;
    DCT3Dtab1[82].val = 209; DCT3Dtab1[82].len = 8;
    DCT3Dtab1[83].val = 209; DCT3Dtab1[83].len = 8;
    DCT3Dtab1[84].val = 34; DCT3Dtab1[84].len = 8;
    DCT3Dtab1[85].val = 34; DCT3Dtab1[85].len = 8;
    DCT3Dtab1[86].val = 34; DCT3Dtab1[86].len = 8;
    DCT3Dtab1[87].val = 34; DCT3Dtab1[87].len = 8;
    DCT3Dtab1[88].val = 19; DCT3Dtab1[88].len = 8;
    DCT3Dtab1[89].val = 19; DCT3Dtab1[89].len = 8;
    DCT3Dtab1[90].val = 19; DCT3Dtab1[90].len = 8;
    DCT3Dtab1[91].val = 19; DCT3Dtab1[91].len = 8;
    DCT3Dtab1[92].val = 5; DCT3Dtab1[92].len = 8;
    DCT3Dtab1[93].val = 5; DCT3Dtab1[93].len = 8;
    DCT3Dtab1[94].val = 5; DCT3Dtab1[94].len = 8;
    DCT3Dtab1[95].val = 5; DCT3Dtab1[95].len = 8;
  }
  
  static void initDCT3D2(){

    int x;

    DCT3Dtab2 = new vlctabh[120];

    for (int i = 0; i < 120; i++)
      DCT3Dtab2[i] = new vlctabh();

    DCT3Dtab2[0].val = 4114; DCT3Dtab2[0].len = 11;
    DCT3Dtab2[1].val = 4114; DCT3Dtab2[1].len = 11;
    DCT3Dtab2[2].val = 4099; DCT3Dtab2[2].len = 11;
    DCT3Dtab2[3].val = 4099; DCT3Dtab2[3].len = 11;
    DCT3Dtab2[4].val = 11; DCT3Dtab2[4].len = 11;
    DCT3Dtab2[5].val = 11; DCT3Dtab2[5].len = 11;
    DCT3Dtab2[6].val = 10; DCT3Dtab2[6].len = 11;
    DCT3Dtab2[7].val = 10; DCT3Dtab2[7].len = 11;
    DCT3Dtab2[8].val = 4545; DCT3Dtab2[8].len = 10;
    DCT3Dtab2[9].val = 4545; DCT3Dtab2[9].len = 10;
    DCT3Dtab2[10].val = 4545; DCT3Dtab2[10].len = 10;
    DCT3Dtab2[11].val = 4545; DCT3Dtab2[11].len = 10;
    DCT3Dtab2[12].val = 4529; DCT3Dtab2[12].len = 10;
    DCT3Dtab2[13].val = 4529; DCT3Dtab2[13].len = 10;
    DCT3Dtab2[14].val = 4529; DCT3Dtab2[14].len = 10;
    DCT3Dtab2[15].val = 4529; DCT3Dtab2[15].len = 10;
    DCT3Dtab2[16].val = 4513; DCT3Dtab2[16].len = 10;
    DCT3Dtab2[17].val = 4513; DCT3Dtab2[17].len = 10;
    DCT3Dtab2[18].val = 4513; DCT3Dtab2[18].len = 10;
    DCT3Dtab2[19].val = 4513; DCT3Dtab2[19].len = 10;
    DCT3Dtab2[20].val = 4497; DCT3Dtab2[20].len = 10;
    DCT3Dtab2[21].val = 4497; DCT3Dtab2[21].len = 10;
    DCT3Dtab2[22].val = 4497; DCT3Dtab2[22].len = 10;
    DCT3Dtab2[23].val = 4497; DCT3Dtab2[23].len = 10;
    DCT3Dtab2[24].val = 146; DCT3Dtab2[24].len = 10;
    DCT3Dtab2[25].val = 146; DCT3Dtab2[25].len = 10;
    DCT3Dtab2[26].val = 146; DCT3Dtab2[26].len = 10;
    DCT3Dtab2[27].val = 146; DCT3Dtab2[27].len = 10;
    DCT3Dtab2[28].val = 130; DCT3Dtab2[28].len = 10;
    DCT3Dtab2[29].val = 130; DCT3Dtab2[29].len = 10;
    DCT3Dtab2[30].val = 130; DCT3Dtab2[30].len = 10;
    DCT3Dtab2[31].val = 130; DCT3Dtab2[31].len = 10;
    DCT3Dtab2[32].val = 114; DCT3Dtab2[32].len = 10;
    DCT3Dtab2[33].val = 114; DCT3Dtab2[33].len = 10;
    DCT3Dtab2[34].val = 114; DCT3Dtab2[34].len = 10;
    DCT3Dtab2[35].val = 114; DCT3Dtab2[35].len = 10;
    DCT3Dtab2[36].val = 98; DCT3Dtab2[36].len = 10;
    DCT3Dtab2[37].val = 98; DCT3Dtab2[37].len = 10;
    DCT3Dtab2[38].val = 98; DCT3Dtab2[38].len = 10;
    DCT3Dtab2[39].val = 98; DCT3Dtab2[39].len = 10;
    DCT3Dtab2[40].val = 82; DCT3Dtab2[40].len = 10;
    DCT3Dtab2[41].val = 82; DCT3Dtab2[41].len = 10;
    DCT3Dtab2[42].val = 82; DCT3Dtab2[42].len = 10;
    DCT3Dtab2[43].val = 82; DCT3Dtab2[43].len = 10;
    DCT3Dtab2[44].val = 51; DCT3Dtab2[44].len = 10;
    DCT3Dtab2[45].val = 51; DCT3Dtab2[45].len = 10;
    DCT3Dtab2[46].val = 51; DCT3Dtab2[46].len = 10;
    DCT3Dtab2[47].val = 51; DCT3Dtab2[47].len = 10;
    DCT3Dtab2[48].val = 35; DCT3Dtab2[48].len = 10;
    DCT3Dtab2[49].val = 35; DCT3Dtab2[49].len = 10;
    DCT3Dtab2[50].val = 35; DCT3Dtab2[50].len = 10;
    DCT3Dtab2[51].val = 35; DCT3Dtab2[51].len = 10;
    DCT3Dtab2[52].val = 20; DCT3Dtab2[52].len = 10;
    DCT3Dtab2[53].val = 20; DCT3Dtab2[53].len = 10;
    DCT3Dtab2[54].val = 20; DCT3Dtab2[54].len = 10;
    DCT3Dtab2[55].val = 20; DCT3Dtab2[55].len = 10;
    DCT3Dtab2[56].val = 12; DCT3Dtab2[56].len = 11;
    DCT3Dtab2[57].val = 12; DCT3Dtab2[57].len = 11;
    DCT3Dtab2[58].val = 21; DCT3Dtab2[58].len = 11;
    DCT3Dtab2[59].val = 21; DCT3Dtab2[59].len = 11;
    DCT3Dtab2[60].val = 369; DCT3Dtab2[60].len = 11;
    DCT3Dtab2[61].val = 369; DCT3Dtab2[61].len = 11;
    DCT3Dtab2[62].val = 385; DCT3Dtab2[62].len = 11;
    DCT3Dtab2[63].val = 385; DCT3Dtab2[63].len = 11;
    DCT3Dtab2[64].val = 4561; DCT3Dtab2[64].len = 11;
    DCT3Dtab2[65].val = 4561; DCT3Dtab2[65].len = 11;
    DCT3Dtab2[66].val = 4577; DCT3Dtab2[66].len = 11;
    DCT3Dtab2[67].val = 4577; DCT3Dtab2[67].len = 11;
    DCT3Dtab2[68].val = 4593; DCT3Dtab2[68].len = 11;
    DCT3Dtab2[69].val = 4593; DCT3Dtab2[69].len = 11;
    DCT3Dtab2[70].val = 4609; DCT3Dtab2[70].len = 11;
    DCT3Dtab2[71].val = 4609; DCT3Dtab2[71].len = 11;
    DCT3Dtab2[72].val = 22; DCT3Dtab2[72].len = 12;
    DCT3Dtab2[73].val = 36; DCT3Dtab2[73].len = 12;
    DCT3Dtab2[74].val = 67; DCT3Dtab2[74].len = 12;
    DCT3Dtab2[75].val = 83; DCT3Dtab2[75].len = 12;
    DCT3Dtab2[76].val = 99; DCT3Dtab2[76].len = 12;
    DCT3Dtab2[77].val = 162; DCT3Dtab2[77].len = 12;
    DCT3Dtab2[78].val = 401; DCT3Dtab2[78].len = 12;
    DCT3Dtab2[79].val = 417; DCT3Dtab2[79].len = 12;
    DCT3Dtab2[80].val = 4625; DCT3Dtab2[80].len = 12;
    DCT3Dtab2[81].val = 4641; DCT3Dtab2[81].len = 12;
    DCT3Dtab2[82].val = 4657; DCT3Dtab2[82].len = 12;
    DCT3Dtab2[83].val = 4673; DCT3Dtab2[83].len = 12;
    DCT3Dtab2[84].val = 4689; DCT3Dtab2[84].len = 12;
    DCT3Dtab2[85].val = 4705; DCT3Dtab2[85].len = 12;
    DCT3Dtab2[86].val = 4721; DCT3Dtab2[86].len = 12;
    DCT3Dtab2[87].val = 4737; DCT3Dtab2[87].len = 12;
    DCT3Dtab2[88].val = 7167; DCT3Dtab2[88].len = 7;
    DCT3Dtab2[89].val = 7167; DCT3Dtab2[89].len = 7;
    DCT3Dtab2[90].val = 7167; DCT3Dtab2[90].len = 7;
    DCT3Dtab2[91].val = 7167; DCT3Dtab2[91].len = 7;
    DCT3Dtab2[92].val = 7167; DCT3Dtab2[92].len = 7;
    DCT3Dtab2[93].val = 7167; DCT3Dtab2[93].len = 7;
    DCT3Dtab2[94].val = 7167; DCT3Dtab2[94].len = 7;
    DCT3Dtab2[95].val = 7167; DCT3Dtab2[95].len = 7;
    DCT3Dtab2[96].val = 7167; DCT3Dtab2[96].len = 7;
    DCT3Dtab2[97].val = 7167; DCT3Dtab2[97].len = 7;
    DCT3Dtab2[98].val = 7167; DCT3Dtab2[98].len = 7;
    DCT3Dtab2[99].val = 7167; DCT3Dtab2[99].len = 7;
    DCT3Dtab2[100].val = 7167; DCT3Dtab2[100].len = 7;
    DCT3Dtab2[101].val = 7167; DCT3Dtab2[101].len = 7;
    DCT3Dtab2[102].val = 7167; DCT3Dtab2[102].len = 7;
    DCT3Dtab2[103].val = 7167; DCT3Dtab2[103].len = 7;
    DCT3Dtab2[104].val = 7167; DCT3Dtab2[104].len = 7;
    DCT3Dtab2[105].val = 7167; DCT3Dtab2[105].len = 7;
    DCT3Dtab2[106].val = 7167; DCT3Dtab2[106].len = 7;
    DCT3Dtab2[107].val = 7167; DCT3Dtab2[107].len = 7;
    DCT3Dtab2[108].val = 7167; DCT3Dtab2[108].len = 7;
    DCT3Dtab2[109].val = 7167; DCT3Dtab2[109].len = 7;
    DCT3Dtab2[110].val = 7167; DCT3Dtab2[110].len = 7;
    DCT3Dtab2[111].val = 7167; DCT3Dtab2[111].len = 7;
    DCT3Dtab2[112].val = 7167; DCT3Dtab2[112].len = 7;
    DCT3Dtab2[113].val = 7167; DCT3Dtab2[113].len = 7;
    DCT3Dtab2[114].val = 7167; DCT3Dtab2[114].len = 7;
    DCT3Dtab2[115].val = 7167; DCT3Dtab2[115].len = 7;
    DCT3Dtab2[116].val = 7167; DCT3Dtab2[116].len = 7;
    DCT3Dtab2[117].val = 7167; DCT3Dtab2[117].len = 7;
    DCT3Dtab2[118].val = 7167; DCT3Dtab2[118].len = 7;
    DCT3Dtab2[119].val = 7167; DCT3Dtab2[119].len = 7;
    
  }
  
}
