
import java.lang.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;

public class globals{

  public static tmndech tmnh;
  
  public static int T_YUV = 0;
  public static int T_SIF = 1;
  public static int T_TGA = 2;
  public static int T_PPM = 3;
  public static int T_X11 = 4;
  public static int T_YUV_CONC = 5;

  public static String version = new String("tmndecode v1.6a (C) Telenor R&D. Ported by Avneesh, Northeast Parallel Architectures Center (NPAC) , Syracuse, NY");
  public static int zig_zag_scan[] = 
    {
      0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,
      12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,
      35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,
      58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63
    };

  public static int convmat[][] = 
    {
      {117504, 138453, 13954, 34903}, /* no sequence_display_extension */
      {117504, 138453, 13954, 34903}, /* ITU-R Rec. 709 (1990) */
      {104597, 132201, 25675, 53279}, /* unspecified */
      {104597, 132201, 25675, 53279}, /* reserved */
      {104448, 132798, 24759, 53109}, /* FCC */
      {104597, 132201, 25675, 53279}, /* ITU-R Rec. 624-4 System B, G */
      {104597, 132201, 25675, 53279}, /* SMPTE 170M */
      {117579, 136230, 16907, 35559}
    };
  
  public static int quiet;
  public static int trace;
  public static int refframe[][];
  public static int oldrefframe[][];
  public static int bframe[][];
  public static int newframe[][];
  public static int edgeframe[];/* Make this 1 D array indexing to edgeorig*/
  public static int edgeframeorig[][];
  public static int exnewframe[][];
  public static int MV[][][][];
  public static int modemap[][];
  public static int clp[];
  public static int horizontal_size, vertical_size, mb_width, mb_height;
  public static int coded_picture_width, coded_picture_height;
  public static int chrom_width, chrom_height, blk_cnt;
  public static int pict_type, newgob;
  public static int mv_outside_frame, syntax_arith_coding, adv_pred_mode, pb_frame;
  public static int long_vectors;
  public static int fault, expand;
  public static int verbose;
  public static int refidct;
  public static int matrix_coefficients;
  public static int temp_ref, quant, source_format, tr_framenum[];
  /* Next two only if we use time for rate control */
  public static int framerate;
  public static timeval tftarget;
  public static int trd, trb, bscan, bquant;
  public static int bscan_tab[] = {2,4,6,8};
  public static int bquant_tab[] = {5,6,7,8};
  /* Added by avneesh here */
  public static char u422[];
  public static char v422[];
  public static char u444[];
  public static char v444[];
  public static int OM[][][] = 
    {
      {
	{4,5,5,5,5,5,5,4},
	{5,5,5,5,5,5,5,5},
	{5,5,6,6,6,6,5,5},
	{5,5,6,6,6,6,5,5},
	{5,5,6,6,6,6,5,5},
	{5,5,6,6,6,6,5,5},
	{5,5,5,5,5,5,5,5},
	{4,5,5,5,5,5,5,4},
      },{
	{2,2,2,2,2,2,2,2},
	{1,1,2,2,2,2,1,1},
	{1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1},
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0},
      },{
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0},
	{1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1},
	{1,1,2,2,2,2,1,1},
	{2,2,2,2,2,2,2,2},
      },{
	{0,0,0,0,1,1,1,2},
	{0,0,0,0,1,1,2,2},
	{0,0,0,0,1,1,2,2},
	{0,0,0,0,1,1,2,2},
	{0,0,0,0,1,1,2,2},
	{0,0,0,0,1,1,2,2},
	{0,0,0,0,1,1,2,2},
	{0,0,0,0,1,1,1,2},
      },{
	{2,1,1,1,0,0,0,0},
	{2,2,1,1,0,0,0,0},
	{2,2,1,1,0,0,0,0},
	{2,2,1,1,0,0,0,0},
	{2,2,1,1,0,0,0,0},
	{2,2,1,1,0,0,0,0},
	{2,2,1,1,0,0,0,0},
	{2,1,1,1,0,0,0,0},
      }
    };
  
  public static int roundtab[] = {0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,2};
  public static StringBuffer outputname;
  public static int outtype;

  public static ldStruct ld;

  /* Static classes for files declared here */
  public static getbts NPACGetBits;
  public static getblk NPACGetBlk;
  public static tmndec NPACH263Dec;
  public static gethdr NPACGetHdr;
  public static getvlc NPACGetVlc;
  public static idct NPACIdct;
  public static idctref NPACIdctRef;
  public static sac NPACSac;
  public static getpic NPACGetPic;
  public static store NPACStore;
  public static recon NPACRecon;
  public static dither NPACDither;
  public static vodclient NPACVodClient;
  
  /* Header files */
  public static indicesh NPACIndecesh;
  public static sactblsh NPACSactblsh;
  public static getvlch NPACGetvlch;
  public static vodjavah NPACVodJava;

  /* Display stuff */
  public static int pix[];
  public static Thread kicker;
  public static ColorModel cmodel;
  public static int cmap[];
  public static int pixel[];
  public static int ytab[];
  public static char uvtab[];

  /* Network I/O Stuff */
  public static BufferedInputStream data;
  public static InputStream cmdin;
  public static OutputStream cmdout;
  public static String fileName;
  public static Thread net;
  public static Socket dataSock;
  public static Socket commandSock;

  public void initGlobals(){

    tmnh = new tmndech();
    NPACIndecesh = new indicesh();
    NPACSactblsh = new sactblsh();
    NPACGetvlch = new getvlch();
    NPACVodJava = new vodjavah();
    NPACGetvlch.initArrays();
    
    tftarget = new timeval();
    
    allocGlobalArrays();
    
    /* Init the ld struct */
    ld = new ldStruct();
    ld.rdbfr = new int[2051];
    ld.rdptr = 0;
    ld.inbfr = new int[16];
    ld.block = new short[12][64];
    
    NPACGetBits = new getbts();
    NPACGetBlk = new getblk();
    NPACH263Dec = new tmndec();
    NPACGetHdr = new gethdr();
    NPACGetVlc = new getvlc();
    NPACIdct = new idct();
    NPACIdctRef = new idctref();
    NPACSac = new sac();
    NPACGetPic = new getpic();
    NPACStore = new store();
    NPACRecon = new recon();
    NPACDither = new dither();
    NPACVodClient = new vodclient();
  }

  void allocGlobalArrays(){
    
    refframe = new int[3][];
    oldrefframe = new int[3][];
    bframe = new int[3][];
    newframe = new int[3][];

    edgeframe = new int[3];
    edgeframeorig = new int[3][];
    exnewframe = new int[3][];
    
    MV = new int[2][5][tmnh.MBR + 1][tmnh.MBC + 2];
    modemap = new int[tmnh.MBR + 1][tmnh.MBC + 2];
    cmap = new int[256];
    ytab = new int[16 * (256 + 16)];
    uvtab = new char[256 * 269 + 270];
    pixel = new int[256];
    
    tr_framenum = new int [1];
    
    coded_picture_width = 176; coded_picture_height = 144;
/*    u422 = new char[(int) ((int) (coded_picture_width>>1) * (int) (coded_picture_height))];
    v422 = new char[(coded_picture_width>>1) * (coded_picture_height)];
    u444 = new char[coded_picture_width * coded_picture_height];
    v444 = new char[coded_picture_width * coded_picture_height];*/
    pix = new int[coded_picture_width * coded_picture_height];
    coded_picture_width = coded_picture_height = 0;
    System.out.println("Arrays initialised.");

  }

  public static int mmax(int a, int b){

    if (a > b)
      return a;
    else
      return b;
  }

  public static int mmin(int a, int b){

    if (a < b)
      return a;
    else
      return b;
  }

  public static int mnint(int a){

    if (a < 0)
      return (int)(a - 0.5);
    else
      return (int)(a + 0.5);
  }

  public static int sign(int a){

    if (a < 0)
      return -1;
    else
      return 1;
  }

}
