
import java.lang.*;
import java.awt.*;
import java.awt.image.*;
import java.applet.*;

public class image extends Applet implements Runnable{

  static Panel com;
  static Image img;
  static MemoryImageSource source;
  static Graphics g;
  int w = 100;
  int h = 100;
  int pix[] = new int[w * h];
  Thread kicker;
  
  public void dummy(){

    boolean res;
    
    System.out.println("In dummy.");
    
    source = new java.awt.image.MemoryImageSource(w, h, pix, 0, w);
    
    img = createImage(source);

    res = false;

    while(!res)    
	    res = prepareImage(img, 100, 100, this);
    
    if (res == true)
      System.out.println("Image is prepared.");
    else 
      System.out.println("Image not prepared");
  
    res = imageUpdate(img, 0, 0, 0, w, h);
    
    if (res == true)
      System.out.println("Image has changed.");
    else 
      System.out.println("Image hasn't changed");

  }

  public void constructImage(int arg){

    int index = 0;
    for (int y = 0; y < h; y++) {
      int red = (y * 255) / (h - 1);
      for (int x = 0; x < w; x++) {
	int blue = (x * 255) / (w - 1);
	if (arg % 2 == 0){
/*		pix[index++] = ((255 << 24) + x) | ((red << 16) + x) | (blue + x);
*/
	        pix[index++] = (x << 24) | (x << 16) | x;

		if (index == 1)
			System.out.println("Color");
	}
	else{
		pix[index++] = 0;
		if (index == 1)
			System.out.println("Black and white.");
	}
      }
    }

  }

  public void paint(Graphics g){

    System.out.println("I am in paint!!");
    g.drawImage(img, 0, 0, 100, 100, this);

  }


/*  public void update(Graphics g){

    System.out.println("I am in update!!");
    g.clear(img, 0, 0, 100, 100);
    paint(g);

  }

*/
  public void start(){

    System.out.println("Start.");

    if (kicker == null){
      kicker = new Thread(this);
      kicker.start();
    }
    
  }

  public void run(){
	
    boolean res;

    System.out.println("In run!");
    
    while(kicker != null){
      for (int x = 1; x < 100; x++){
	constructImage(x);
	System.out.println("Repainting." + x);
/*	res = false;
	while(!res)
		res = prepareImage(img, 100, 100, this);	*/
	img = createImage(source);
	repaint();
	try{
	  kicker.sleep(3000);
	}
	catch(Exception e){System.out.println("Interrupted sleep");}
      }
      kicker.stop();
      kicker = null;
    }
    
  }

  public void stop(){

    System.out.println("Stop.");
    
    if (kicker != null){
      kicker.stop();
      kicker = null;
    }
    
  }

  public void init(){

    System.out.println("Init.");

    resize(100, 100);
    constructImage(0);
    dummy();
    repaint();

/*    boolean res;

    setLayout(new FlowLayout());

    repaint();

    show();

    validate();
    
    enable();

    res = isShowing();
    
    if (res)
      System.out.println("Component is showing");
*/
    

  }

}
