
import java.lang.*;
import java.io.*;

public class store{
  
  static globals jva;
  static indicesh jvaind;
  static sactblsh jvasach;
  static getvlch jvavlc;
  static sac jvasac;
  
  public static char tga24[] = {0,0,2,0,0,0,0, 0,0,0,0,0,24,32};
  public static FileOutputStream outfile;
  public static byte obfr[] = new byte[4096];
  public static int optr;
  public static int clp[];
  
  public static void storeframe(int src[][], int frame){
    
    StringBuffer outname = new StringBuffer(20);
  
    /* progressive */
    outname.append(jva.outputname).append(".").append(frame);		
    /* store_one(outname, src, 0, jva.coded_picture_width, jva.vertical_size);*/
    jva.NPACDither.ord4x4_dither_frame(src);
  }
  
  
  public static void store_one(StringBuffer outname, int src[][], 
			       int offset,int incr,int height)
      {
	
	switch (jva.outtype){
	case 3: /* Const for PPM in globals.java */
	  store_ppm_tga(outname,src,offset,incr,height,0);
	  break;
	default:
	  System.out.println("Unsupported output format. Exiting.");
	  System.exit(1);
	  break;
	}
      }
  
  public static void store_ppm_tga(StringBuffer outname, int src[][],
				   int offset, int incr, int height, 
				   int tgaflag){
				     
    int i, j;
    int y, u, v, r, g, b;
    int crv, cbu, cgu, cgv;
    int py, pu, pv;
    StringBuffer header = new StringBuffer(20);
    int idx = 0;
    int pixel;

    clp = jva.clp;

    conv420to422(src[1],jva.u422);
    conv420to422(src[2],jva.v422);
    conv422to444(jva.u422,jva.u444);
    conv422to444(jva.v422,jva.v444);

    if (tgaflag != 0)
      outname.append(".tga");
    else
      outname.append(".ppm");
    
/*    if (jva.quiet == 0)
      System.out.println("Saving " + outname);

    System.out.flush();

    try{
      outfile = new FileOutputStream(outname.toString());
    }
    catch (Exception e){System.out.println("File write exception");}
  */  
    optr = 0;
    /*
    if (tgaflag != 0){
      for (i = 0; i < 12; i++)
	putbyte(tga24[i]);

      putword(jva.horizontal_size); putword(height);
      putbyte(tga24[12]); putbyte(tga24[13]);
    }
    else{
      header.append("P6\n").append(jva.horizontal_size).append(" ");
      header.append(height).append("\n255\n");

      for (i = 0; i < header.length(); i++)
	putbyte(header.charAt(i));
    }
    */
     /* matrix coefficients */
    crv = jva.convmat[jva.matrix_coefficients][0];
    cbu = jva.convmat[jva.matrix_coefficients][1];
    cgu = jva.convmat[jva.matrix_coefficients][2];
    cgv = jva.convmat[jva.matrix_coefficients][3];
    
    for (i=0; i<height; i++) {
      py = offset + incr*i;
      pu = offset + incr*i;
      pv = offset + incr*i;
      for (j=0; j<jva.horizontal_size; j++) {
	u = jva.u444[pu] - 128;
	v = jva.v444[pv] - 128;
	y = 76309 * (src[0][py] - 16); /* (255/219)*65536 */
	pu++;pv++;py++;
	r = clp[((int) (y + crv*v + 32768)>>16) + 384];
	g = clp[((int) (y - cgu*u - cgv*v + 32768)>>16) + 384];
	b = clp[((int) (y + cbu*u + 32786)>>16) + 384];
	
	if (b > 255)
	  b = 255;
	if (r > 255) 
	  r = 255;
	if (g > 255)
	  g = 255;

	pixel = (r << 16) | (g << 8) | b;
	r = jva.cmodel.getRed(pixel);
	g = jva.cmodel.getGreen(pixel);
	b = jva.cmodel.getBlue(pixel);
	
	jva.pix[idx] = (r << 16) | (g << 8) | b;
	idx++;
	
	/*	if (tgaflag != 0) {
		putbyte((char) b); putbyte((char) g); putbyte((char) r);
		}
		else {
		putbyte((char) r); putbyte((char) g); putbyte((char) b);
		}	
		*/
      }	
    }	
    
    /*    if (optr != 0){
	  try{
	  outfile.write(obfr, 0, optr);
	  }
	  catch(Exception e){}
	  }
	  
	  
	  try{
	  outfile.close();    
	  }
	  catch(Exception e){}
	  */  
  }
  
  public static void putbyte(char c){


    obfr[optr] = (byte) c;
    optr++;
    
    if (optr == 4096){
      try{
	outfile.write(obfr, 0, 4096);
      }
      catch(Exception e){System.out.println("Exception during write");}
      optr = 0;
    }
  }

  public static void putword(int w){

    char c;

    c = (char) w;

    putbyte(c);
    
    c = (char) (w >> 8);
    putbyte(c);

  }

  /* horizontal 1:2 interpolation filter */
  public static void conv422to444(char src[], char dst[]){
    
    int i, i2, w, j, im3, im2, im1, ip1, ip2, ip3;
    int od, os;
    int temp;

    w = jva.coded_picture_width>>1;
    os = 0; od = 0;
    for (j=0; j<jva.coded_picture_height; j++) {
      for (i=0; i<w; i++) {
	i2 = i<<1;
	im3 = (i<3) ? 0 : i-3;
	im2 = (i<2) ? 0 : i-2;
	im1 = (i<1) ? 0 : i-1;
	ip1 = (i<w-1) ? i+1 : w-1;
	ip2 = (i<w-2) ? i+2 : w-1;
	ip3 = (i<w-3) ? i+3 : w-1;
	
	temp = (int)((5*src[os + im3]
		      -21*src[os + im2]
		      +70*src[os + im1]
		      +228*src[os + i]
		      -37*src[os + ip1]
		      +11*src[os + ip2]+128)>>8) + 384;
	
	/* FIR filter coefficients (*256): 5 -21 70 228 -37 11 */
	dst[od + i2] =   (char) clp[temp];
	
	temp = (int)((5*src[os + ip3]
		      -21*src[os + ip2]
		      +70*src[os + ip1]
		      +228*src[os + i]
		      -37*src[os + im1]
		      +11*src[os + im2]+128)>>8) + 384;

	dst[od + i2+1] = (char) clp[temp];
      }
      os += w;
      od += jva.coded_picture_width;
    }
  }

  /* vertical 1:2 interpolation filter */
  public static void conv420to422(int src[], char dst[]){
    
    int w, h, i, j, j2;
    int jm3, jm2, jm1, jp1, jp2, jp3;
    int os, od;
    int temp;

    w = jva.coded_picture_width>>1;
    h = jva.coded_picture_height>>1;
    os  = 0; od = 0;

    /* intra frame */
    for (i=0; i<w; i++) {
      for (j=0; j<h; j++) {
	j2 = j<<1;
	jm3 = (j<3) ? 0 : j-3;
	jm2 = (j<2) ? 0 : j-2;
	jm1 = (j<1) ? 0 : j-1;
	jp1 = (j<h-1) ? j+1 : h-1;
	jp2 = (j<h-2) ? j+2 : h-1;
	jp3 = (j<h-3) ? j+3 : h-1;

	/* FIR filter coefficients (*256): 5 -21 70 228 -37 11 */
	/* New FIR filter coefficients (*256): 3 -16 67 227 -32 7 */
	temp = (int)((3*src[os + (w*jm3)]
		      -16*src[os + (w*jm2)]
		      +67*src[os + (w*jm1)]
		      +227*src[os + (w*j)]
		      -32*src[os + (w*jp1)]
		      +7*src[os + (w*jp2)]+128) >> 8) + 384;
	
	dst[od + (w*j2)] = (char) clp[temp];
	
	temp = (int)((3*src[os + (w*jp3)]
		      -16*src[os + (w*jp2)]
		      +67*src[os + (w*jp1)]
		      +227*src[os + (w*j)]
		      -32*src[os + (w*jm1)]
		      +7*src[os + (w*jm2)]+128)>>8) + 384;

	dst[od + (w*(j2+1))] = (char) clp[temp];

      }
      os++;
      od++;
    }
  }
  
}
